/*-
 * Copyright (c) 2010 Alistair Crooks <agc@NetBSD.org>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
#ifndef OTK_H_
#define OTK_H_	20101130

#ifndef OTK_VERSION
#define OTK_VERSION	"20101130"
#endif

enum {
	KEYID_LENGTH	= 32
};

/* structure describing a one time key share */
typedef struct sharedkey_t {
	char		*splitdir;	/* directory holding the shares */
	char		*out;		/* output file for recovery */
	int		 anon;		/* anonymous splitting */
	unsigned	 threshold;	/* threshold # of shares */
	unsigned	 shares;	/* total number of shares */
	unsigned	 numbits;	/* number of bits in new key */
	char		 keyid[KEYID_LENGTH];	/* one time key id */
} sharedkey_t;

int sharedkey_share(sharedkey_t *, const char *, const char *);
int sharedkey_recover(sharedkey_t *, const char *, int, char **);

#endif
