#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include "bufgap.h"

int
main(int argc, char **argv)
{
	bufgap_t	gap;
	int		i;

	(void) memset(&gap, 0x0, sizeof(gap));
	while ((i = getopt(argc, argv, "")) != -1) {
	}
	if (argc == optind) {
		(void) fprintf(stderr, "No file given\n");
		exit(EXIT_FAILURE);
	}
	if (!bufgap_open(&gap, argv[optind])) {
		(void) fprintf(stderr, "can't open file '%s'\n", argv[optind]);
		exit(EXIT_FAILURE);
	}
	for (i = bufgap_size(&gap, BGByte) - 1 ; i >= 0 ; --i) {
		fputc(bufgap_peek(&gap, 0), stdout);
		(void) bufgap_seek(&gap, 1, BGFromHere, BGByte);
	}
	printf("\n===========\n");
	for (i = bufgap_size(&gap, BGByte) - 1 ; i >= 0 ; --i) {
		fputc(bufgap_peek(&gap, 0), stdout);
		(void) bufgap_seek(&gap, -1, BGFromHere, BGByte);
	}
	printf("\n===========\n");
	for (i = bufgap_size(&gap, BGByte) - 1 ; i >= 0 ; --i) {
		fputc(bufgap_peek(&gap, 0), stdout);
		(void) bufgap_seek(&gap, 1, BGFromHere, BGByte);
	}
	printf("\n===========\n");
	exit(EXIT_SUCCESS);
}
