/* $NetBSD$ */

/*-
 * Copyright (c) 2005,2011 Alistair Crooks <agc@NetBSD.org>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
#include <sys/cdefs.h>

#include <err.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include "find2.h"

/* Here we go, here we go, here we go... */
int
main(int argc, char **argv)
{
	find_t	find;
	int	ret;
	int	i;

	(void) memset(&find, 0, sizeof(find));
	while ((i = getopt(argc, argv, "0HLPXilvx")) != -1) {
		switch(i) {
		case '0':
			find.nulterm = 1;
			break;
		case 'H':
		case 'L':
			find.usestat = 1;
			break;
		case 'P':
			find.usestat = 0;
			break;
		case 'X':
			find.nofollow = 1;
			break;
		case 'i':
			find.ignorecase = 1;
			break;
		case 'l':
			find.longlist = 1;
			break;
		case 'v':
			find.verbose = 1;
			break;
		case 'x':
			find.samedev = 1;
			break;
		}
	}
	if (argc - optind < 2) {
		(void) fprintf(stderr, "Usage: %s -[0HLPXilvx] condition dir...\n", *argv);
		exit(EXIT_FAILURE);
	}
	if (!find2_parse(&find, argv[optind])) {
		errx(EXIT_FAILURE, "invalid clause `%s'", argv[optind]);
	}
	for (ret = EXIT_SUCCESS, i = optind + 1 ; i < argc ; i++) {
		if (!find2(&find, argv[i], stdout)) {
			ret = EXIT_FAILURE;
		}
	}
	return ret;
}
