# $NetBSD: bsd.setlist.mk,v 1.6 2011/05/30 03:49:56 agc Exp $

# Copyright (c) 2010,2011 Alistair Crooks <agc@NetBSD.org>
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

# Makefile fragment to hand the args to "gensetlist" from the Makefile

.if defined(LIB)
GENSETLIST_ARGS+=-v LIB=${LIB:Q}
GENSETLIST_ARGS+=-v SHLIB_VERSION=${SHLIB_MAJOR}.${SHLIB_MINOR}.${SHLIB_TEENY}
GENSETLIST_ARGS+=-v LIBDIR=${LIBDIR:Q}
.endif

.if defined(MAN)
.  if defined(MKMAN) && ${MKMAN} != "no"
GENSETLIST_ARGS+=-v MAN=${MAN:Q}
GENSETLIST_ARGS+=-v MANDIR=${MANDIR:Q}
.  endif
.endif

.if defined(INCS)
GENSETLIST_ARGS+=-v INCS=${INCS:Q}
GENSETLIST_ARGS+=-v INCSDIR=${INCSDIR:Q}
.endif

.if defined(PROG)
GENSETLIST_ARGS+=-v PROG=${PROG:Q}
GENSETLIST_ARGS+=-v BINDIR=${BINDIR:Q}
.endif

.if defined(SCRIPTS)
GENSETLIST_ARGS+=-v SCRIPTS=${SCRIPTS:Q}
GENSETLIST_ARGS+=-v SCRIPTSDIR=${SCRIPTSDIR:Q}
.endif

.if defined(LINKS)
GENSETLIST_ARGS+=-v LINKS=${LINKS:Q}
.endif

.if defined(MLINKS)
GENSETLIST_ARGS+=-v MLINKS=${MLINKS:Q}
.endif

.if defined(SYMLINKS)
GENSETLIST_ARGS+=-v SYMLINKS=${SYMLINKS:Q}
.endif

# guard keyword i.e. MKWIBBLE - just give the "wibble" part
.if defined(GUARD)
GENSETLIST_ARGS+=-D ${GUARD:Q}
.endif

# syspkg category
.if !defined(CATEGORY)
.  if defined(PROG)
CATEGORY=${PROG}
.  elif defined(LIB)
CATEGORY=${LIB}
.  elif defined(SCRIPTS)
CATEGORY=${SCRIPTS:Q:C|[. 	]+.*||}
.  endif
.endif
.if defined(CATEGORY)
GENSETLIST_ARGS+=-c ${CATEGORY:Q:C|-||g}
.endif

setlist: .PHONY
	gensetlist ${GENSETLIST_ARGS}
