/*-
 * Copyright (c) 2012 Alistair Crooks <agc@NetBSD.org>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
#ifndef VMDK_H_
#define VMDK_H_	20120103

#include <sys/types.h>

#include <inttypes.h>

#define VMDK_GB(x)	((uint64_t)(x) * 1024 * 1024 * 1024)
#define VMDK_MB(x)	((uint64_t)(x) * 1024 * 1024)

enum {
	VMDK_SECTOR_SIZE		= 512,
	VMDK_SLICE_SIZE			= VMDK_GB(2) - VMDK_MB(1)
};

int vmdk_make_vmdk(const char */*vmname*/, int /*slices*/, uint64_t /*bytes*/);
int vmdk_make_extent(const char */*img*/, uint64_t /*bytes*/);

int vmdk_file_to_vmdk(const char */*desc*/, const char */*f*/);

int vmdk_list_extent(const char */*img*/);
uint64_t vmdk_nearest_size(uint64_t /*bytes*/);

#endif
