/****************************************************************
Copyright (C) Lucent Technologies 1997
All Rights Reserved

Permission to use, copy, modify, and distribute this software and
its documentation for any purpose and without fee is hereby
granted, provided that the above copyright notice appear in all
copies and that both that the copyright notice and this
permission notice and warranty disclaimer appear in supporting
documentation, and that the name Lucent Technologies or any of
its entities not be used in advertising or publicity pertaining
to distribution of the software without specific, written prior
permission.

LUCENT DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS.
IN NO EVENT SHALL LUCENT OR ANY OF ITS ENTITIES BE LIABLE FOR ANY
SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER
IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF
THIS SOFTWARE.
****************************************************************/

#ifndef AWKRE_H_
#define AWKRE_H_

/* structures used by regular expression matching machinery, mostly b.c: */

typedef struct awkrrow_t {
	long	ltype;	/* long avoids pointer warnings on 64-bit */
	union {
		int		 	 i;
		struct awknode_t	*np;
		uint8_t			*up;
	} lval;		/* because Al stores a pointer in it! */
	int	*lfollow;
} awkrrow_t;

typedef struct fa_t {
	unsigned int	**gototab;
	uint8_t		 *out;
	uint8_t		 *restr;
	int		**posns;
	int		  state_count;
	int		  anchor;
	int		  use;
	int		  initstat;
	int		  curstat;
	int		  accept;
	struct awkrrow_t  re[1];	/* variable: actual size set by calling malloc */
} fa_t;

#endif
