#include <stdio.h>

#include "eawk.h"
#include "awkgram.h"
#include "proto.h"

static const char * const printname[107] = {
	"FIRSTTOKEN",	/* 258 */
	"PROGRAM",	/* 259 */
	"PASTAT",	/* 260 */
	"PASTAT2",	/* 261 */
	"XBEGIN",	/* 262 */
	"XEND",		/* 263 */
	"NL",		/* 264 */
	"ARRAY",	/* 265 */
	"MATCH",	/* 266 */
	"NOTMATCH",	/* 267 */
	"MATCHOP",	/* 268 */
	"FINAL",	/* 269 */
	"DOT",		/* 270 */
	"ALL",		/* 271 */
	"CCL",		/* 272 */
	"NCCL",		/* 273 */
	"CHAR",		/* 274 */
	"OR",		/* 275 */
	"STAR",		/* 276 */
	"QUEST",	/* 277 */
	"PLUS",		/* 278 */
	"EMPTYRE",	/* 279 */
	"AND",		/* 280 */
	"BOR",		/* 281 */
	"APPEND",	/* 282 */
	"EQ",		/* 283 */
	"GE",		/* 284 */
	"GT",		/* 285 */
	"LE",		/* 286 */
	"LT",		/* 287 */
	"NE",		/* 288 */
	"IN",		/* 289 */
	"ARG",		/* 290 */
	"BLTIN",	/* 291 */
	"BREAK",	/* 292 */
	"CLOSE",	/* 293 */
	"CONTINUE",	/* 294 */
	"DELETE",	/* 295 */
	"DLALLOC",	/* 296 */
	"DLCALL",	/* 297 */
	"DLCLOSE",	/* 298 */
	"DLFIELD",	/* 299 */
	"DLFREE",	/* 300 */
	"DLOPEN",	/* 301 */
	"DLPROTO",	/* 302 */
	"DO",		/* 303 */
	"EXIT",		/* 304 */
	"FOR",		/* 305 */
	"FUNC",		/* 306 */
	"SUB",		/* 307 */
	"GSUB",		/* 308 */
	"IF",		/* 309 */
	"INDEX",	/* 310 */
	"LSUBSTR",	/* 311 */
	"MATCHFCN",	/* 312 */
	"NEXT",		/* 313 */
	"NEXTFILE",	/* 314 */
	"ADD",		/* 315 */
	"MINUS",	/* 316 */
	"MULT",		/* 317 */
	"DIVIDE",	/* 318 */
	"MOD",		/* 319 */
	"ASSIGN",	/* 320 */
	"ASGNOP",	/* 321 */
	"ADDEQ",	/* 322 */
	"SUBEQ",	/* 323 */
	"MULTEQ",	/* 324 */
	"DIVEQ",	/* 325 */
	"MODEQ",	/* 326 */
	"POWEQ",	/* 327 */
	"PRINT",	/* 328 */
	"PRINTF",	/* 329 */
	"SPRINTF",	/* 330 */
	"ELSE",		/* 331 */
	"INTEST",	/* 332 */
	"CONDEXPR",	/* 333 */
	"POSTINCR",	/* 334 */
	"PREINCR",	/* 335 */
	"POSTDECR",	/* 336 */
	"PREDECR",	/* 337 */
	"VAR",		/* 338 */
	"IVAR",		/* 339 */
	"VARNF",	/* 340 */
	"CALL",		/* 341 */
	"NUMBER",	/* 342 */
	"STRING",	/* 343 */
	"REGEXPR",	/* 344 */
	"GETLINE",	/* 345 */
	"GENSUB",	/* 346 */
	"RETURN",	/* 347 */
	"SPLIT",	/* 348 */
	"SUBSTR",	/* 349 */
	"WHILE",	/* 350 */
	"CAT",		/* 351 */
	"NOT",		/* 352 */
	"UMINUS",	/* 353 */
	"POWER",	/* 354 */
	"DECR",		/* 355 */
	"INCR",		/* 356 */
	"INDIRECT",	/* 357 */
	"BITCOMPL",	/* 358 */
	"BITLSHIFT",	/* 359 */
	"BITRSHIFT",	/* 360 */
	"BITAND",	/* 361 */
	"BITOR",	/* 362 */
	"BITXOR",	/* 363 */
	"LASTTOKEN",	/* 364 */
};


awkcell_t *(*eawk_proctab[107])(eawk_t *, awknode_t **, int) = {
	eawk_nullproc,	/* FIRSTTOKEN */
	eawk_program,	/* PROGRAM */
	eawk_pastat,	/* PASTAT */
	eawk_dopa2,	/* PASTAT2 */
	eawk_nullproc,	/* XBEGIN */
	eawk_nullproc,	/* XEND */
	eawk_nullproc,	/* NL */
	eawk_array,	/* ARRAY */
	eawk_matchop,	/* MATCH */
	eawk_matchop,	/* NOTMATCH */
	eawk_nullproc,	/* MATCHOP */
	eawk_nullproc,	/* FINAL */
	eawk_nullproc,	/* DOT */
	eawk_nullproc,	/* ALL */
	eawk_nullproc,	/* CCL */
	eawk_nullproc,	/* NCCL */
	eawk_nullproc,	/* CHAR */
	eawk_nullproc,	/* OR */
	eawk_nullproc,	/* STAR */
	eawk_nullproc,	/* QUEST */
	eawk_nullproc,	/* PLUS */
	eawk_nullproc,	/* EMPTYRE */
	eawk_boolop,	/* AND */
	eawk_boolop,	/* BOR */
	eawk_nullproc,	/* APPEND */
	eawk_relop,	/* EQ */
	eawk_relop,	/* GE */
	eawk_relop,	/* GT */
	eawk_relop,	/* LE */
	eawk_relop,	/* LT */
	eawk_relop,	/* NE */
	eawk_instat,	/* IN */
	eawk_arg,	/* ARG */
	eawk_bltin,	/* BLTIN */
	eawk_jump,	/* BREAK */
	eawk_closefile,	/* CLOSE */
	eawk_jump,	/* CONTINUE */
	eawk_delete,	/* DELETE */
	eawk_dlalloc,	/* DLALLOC */
	eawk_dlcall,	/* DLCALL */
	eawk_dlclose,	/* DLCLOSE */
	eawk_dlfield,	/* DLFIELD */
	eawk_dlfree,	/* DLFREE */
	eawk_dlopen,	/* DLOPEN */
	eawk_dlproto,	/* DLPROTO */
	eawk_dostat,	/* DO */
	eawk_jump,	/* EXIT */
	eawk_forstat,	/* FOR */
	eawk_nullproc,	/* FUNC */
	eawk_sub,	/* SUB */
	eawk_gsub,	/* GSUB */
	eawk_ifstat,	/* IF */
	eawk_index,	/* INDEX */
	eawk_nullproc,	/* LSUBSTR */
	eawk_matchop,	/* MATCHFCN */
	eawk_jump,	/* NEXT */
	eawk_jump,	/* NEXTFILE */
	eawk_arith,	/* ADD */
	eawk_arith,	/* MINUS */
	eawk_arith,	/* MULT */
	eawk_arith,	/* DIVIDE */
	eawk_arith,	/* MOD */
	eawk_assign,	/* ASSIGN */
	eawk_nullproc,	/* ASGNOP */
	eawk_assign,	/* ADDEQ */
	eawk_assign,	/* SUBEQ */
	eawk_assign,	/* MULTEQ */
	eawk_assign,	/* DIVEQ */
	eawk_assign,	/* MODEQ */
	eawk_assign,	/* POWEQ */
	eawk_print,	/* PRINT */
	eawk_printf,	/* PRINTF */
	eawk_sprintf,	/* SPRINTF */
	eawk_nullproc,	/* ELSE */
	eawk_intest,	/* INTEST */
	eawk_condexpr,	/* CONDEXPR */
	eawk_incrdecr,	/* POSTINCR */
	eawk_incrdecr,	/* PREINCR */
	eawk_incrdecr,	/* POSTDECR */
	eawk_incrdecr,	/* PREDECR */
	eawk_nullproc,	/* VAR */
	eawk_nullproc,	/* IVAR */
	eawk_getnf,	/* VARNF */
	eawk_call,	/* CALL */
	eawk_nullproc,	/* NUMBER */
	eawk_nullproc,	/* STRING */
	eawk_nullproc,	/* REGEXPR */
	eawk_getline,	/* GETLINE */
	eawk_gensub,	/* GENSUB */
	eawk_jump,	/* RETURN */
	eawk_split,	/* SPLIT */
	eawk_substr,	/* SUBSTR */
	eawk_whilestat,	/* WHILE */
	eawk_cat,	/* CAT */
	eawk_boolop,	/* NOT */
	eawk_arith,	/* UMINUS */
	eawk_arith,	/* POWER */
	eawk_nullproc,	/* DECR */
	eawk_nullproc,	/* INCR */
	eawk_indirect,	/* INDIRECT */
	eawk_bitarith,	/* BITCOMPL */
	eawk_bitarith,	/* BITLSHIFT */
	eawk_bitarith,	/* BITRSHIFT */
	eawk_bitarith,	/* BITAND */
	eawk_bitarith,	/* BITOR */
	eawk_bitarith,	/* BITXOR */
	eawk_nullproc,	/* LASTTOKEN */
};

const char *
eawk_tokname(int n, char *buf, size_t size)
{
	if (n < FIRSTTOKEN || n > LASTTOKEN) {
		snprintf(buf, size, "token %d", n);
	} else {
		snprintf(buf, size, "%s", printname[n - FIRSTTOKEN]);
	}
	return buf;
}
