#include	<stdio.h>
#include	<stdlib.h>
#include	<stdarg.h>
#include	<unistd.h>
#include	<time.h>

#include	<sys/param.h>
#include	<miscfs/dmfs/rash.h>
#include	"out.h"
#include	"nasutil.h"

#define	checkout(x)	if ((x) == EOF) { perror(#x); abort(); }

/*
**	Finish a record with a newline.
*/
void
outnl(FILE *fp)
{
	checkout(fputc('\n', fp))
}

/*
**	Output to a file all the char strings without adding
**	a newline.  This is to be able to make several calls
**	to create a single record.
*/
void
outx(FILE *fp, ...)
{
	va_list		ap;
	char		*str;
	int		i;

	va_start(ap, fp);
	for (i=0; (str = va_arg(ap, char *)) != NULL; i++) {
		checkout(fputs(str, fp))
		checkout(fputc('\0', fp))
	}
	va_end(ap);
}

/*
**	Output to a file all the char strings adding
**	a newline.  This will create a record with a single
**	call.
*/
void
out(FILE *fp, ...)
{
	va_list		ap;
	char		*str;
	int		i;

	va_start(ap, fp);
	for (i=0; (str = va_arg(ap, char *)) != NULL; i++) {
		checkout(fputs(str, fp))
		checkout(fputc('\0', fp))
	}
	va_end(ap);
	outnl(fp);
}

char	*
uidname(uid_t uid)
{
	static	char	number[20];
	char	*name;

	if ((name = nas_uidname(uid)) == NULL) {
		sprintf(number, "%d", (int)uid);
		name = number;
	}
	return name;
}

char	*
gidname(gid_t gid)
{
	static	char	number[20];
	char	*name;

	if ((name = nas_gidname(gid)) == NULL) {
		sprintf(number, "%d", (int)gid);
		name = number;
	}
	return name;
}

/*
**	Output a string in the MS66 date format.
*/
char	*
dateout(time_t clock)
{
	static	char	buf[32];
	struct	tm	*tinfo;

	tinfo = gmtime(&clock);
	sprintf(buf, "%4d/%02d/%02d/%02d:%02d:%02d",
		tinfo->tm_year + 1900,
		tinfo->tm_mon + 1,
		tinfo->tm_mday,
		tinfo->tm_hour,
		tinfo->tm_min,
		tinfo->tm_sec);
	return buf;
}

/*
**	Return a string for a file size.
*/
char	*
offout(off_t	len)
{
	static	char	buf[64];

	sprintf(buf, "%lld", (long long)len);
	return buf;
}

