#define	FALSE		0
#define	TRUE		1
#define	INITTOK		32

#ifdef	KEYDEF		/* define keywords */

#define	SETUP(x)	x,
typedef	enum {
#include KEYDEF
	LAST_KEY
} reckey_t;
#undef	SETUP

#define	SETUP(x)	#x,
static	char	*localtab[] = {
#include KEYDEF
	NULL
};
#undef	SETUP

#else

typedef	int	reckey_t;

#endif

/*
**	Set up structures for various data types.
*/
typedef	enum {
	T_STRING,
	T_INTEGER,
	T_STRINTEGER,
	T_OFFSET,
	T_BOOLEAN,
	T_DATE,
	T_NOTYPE
} type_t;

typedef	struct {
	int		(*store)(void *, reckey_t, reckey_t);
	void		*initval;
	int		size;
} store_t;

typedef struct {
	reckey_t	record;
	reckey_t	field;
	int		offset;
	type_t		type;
} field_t;

typedef struct {
	char	*name;
	char	*value;
} namval_t;

#define	OFF(TYPE, FIELD)	(int)&(((TYPE *)0)->FIELD)
#define	FREE(x)			if ((x) != NULL) free(x)
#define	NOKEY	((reckey_t)-1)

extern	char	*token;
extern	int	tokenlen;
extern	int	tokeneol;
extern	int	tokenmax;
extern	int	recordnum;
extern	int	ext_out;
extern	int	ext_num;
extern	int	verbose;
extern	char	**key_tab;

extern	char	*initstr;
extern	int	initint;
extern	char	*initoff;
extern	char	*initbool;
extern	char	*initdate;

int		storestr(void *to, reckey_t rec, reckey_t field);
int		storeint(void *to, reckey_t rec, reckey_t field);
int		savestrint(void *to, reckey_t rec, reckey_t field);
int		storestrint(void *to, reckey_t rec, reckey_t field);
int		storeoff(void *to, reckey_t rec, reckey_t field);
int		storebool(void *to, reckey_t rec, reckey_t field);
int		storedate(void *to, reckey_t rec, reckey_t field);
int		get_token(reckey_t key, reckey_t field);
int		start_token(void);
int		match_token(reckey_t key);
reckey_t	find_key(void);
int		check_key(reckey_t x);
void		store_info(void *obj, reckey_t rec, field_t *tab);
void		init_field(void *obj, field_t *tab);
int		check_field(void *obj, field_t *tab);
void		print_field(field_t *tab);
void		bad_field(void *obj, field_t *tab);
void		free_all(void *obj, field_t *tab);
int		ext_record(void);

int		fsms_description(void);
int		finfo_description(void);
int		fseg_description(void);
int		cart_description(void);
void		putrec(char *table, namval_t *tab, size_t tabsize);
char		*quotestr(void);
char		*stringnum(int num, char *buf);
