#include	<stdio.h>
#include	<stdlib.h>
#include	<unistd.h>

#include	"com.h"

int	verbose = FALSE;

/*
**	Process MS66 meta data records and output sql commands
**	to create a database.
*/
int
main(int argc, char *argv[])
{
	int		c;
	int		finfo, fseg, cart;
	int		errflg = FALSE;
	extern char	*optarg;
	extern int	optind, opterr;  

	while ((c = getopt(argc, argv, "ve")) != EOF) {
		switch (c) { 

		case 'v':
			verbose = TRUE;
			break;

		case 'e':
			ext_out = TRUE;
			break;

		case '?':
		default:
			errflg = TRUE;
			break;
		}
	}
	if (optind != argc)
		errflg = TRUE;

	if (errflg == TRUE) {
		fprintf(stderr, "usage: %s [-ve]\n", argv[0]);
		return 2;
	}

	finfo = fseg = cart = 1;
	get_token(NOKEY, NOKEY);
	fsms_description();		/* this must be first */

	/*
	**	Other meta data types follow in any order.
	*/
	for (;;) {
		if (feof(stdin))
			break;

		c = 1;
		if (finfo) {
			while (finfo_description())
				c = finfo = 0;
		}
		if (fseg) {
			while (fseg_description())
				c = fseg = 0;
		}
		if (cart) {
			while (cart_description())
				c = cart = 0;
		}

		if (c) {	/* nothing recognized */
			fprintf(stderr,
				"token '%s' not recognized or out of place\n",
				token);
			break;
		}
	}

	if (verbose) {
		printf("\nEXT records:\t%d\n", ext_num);
		printf("Total records:\t%d\n", recordnum-1);
	}
	return 0;
}
