create table fsms (
	export_time	datetime,
	version		text,
	hw_vendor	text,
	hw_name		text,
	hw_version	text,
	os_vendor	text,
	os_name		text,
	os_version	text,
	fsms_vendor	text,
	fsms_name	text,
	fsms_version	text,
	export_root	text
);

create table cart (
	cart_id		varchar(16),
	creation	datetime,
	modified	datetime,
	lastmount	datetime,
	mounts		int4,
	noerrors	int2,
	byteorder	varchar(4),
	blocklen	int4,
	data_len	int4,
	hdr_len		int4,
	trl_len		int4,
	partitions	int2,
	sides		int2,
	blocksbetwntm	int2,
	blocksaftertm	int2,
	bytesaftertm	int2,
	blocksize	int4,
	drive_comp	bool,
	volgr_comp	bool,
	volgr_blksize	int4,
	volgr_name	text,
	drive_mfr	text,
	drive_model	text,
	drive_type	text,
	media		text,
	format		text,
	family		text,
	billingid	text,
	library		text,
	place		text,
	lot		text,
	recording_fsms	text
);

create table cartpart (
	cart_id		varchar(16),
	label		varchar(16),
	side		int2,
	partition	int2,
	size		int4,
	freespace	int4,
	part_name	text,
	labeltype	text
);

create table file (
	uid		varchar(32),
	type		char,
	permissions	char(4),
	ownerid		varchar(16),
	groupid		varchar(16),
	length		int8,
	changed		datetime,
	accessed	datetime,
	modified	datetime,
	name		text,
	container	text,
	symlink		text,
	billing		text,
	family		text
);

create table content (
	container_uid	varchar(32),
	uid		varchar(32),
	name		text
);

create table fileseg (
	uid		varchar(32),
	segment		int2,
	copynum		int2,
	width		int2,
	block_len	int4,
	foffset		int8,
	length		int8,
	header		int4,
	trailer		int4,
	name		text
);

create table stripe (
	uid		varchar(32),
	cart_id		varchar(16),
	segment		int2,
	copynum		int2,
	stripe		int2,
	partition	int2,
	side		int2,
	tapemark	int4,
	block		int4,
	record		int4,
	byte		int4,
	cookie		text
);
