/*
 * include file for kernel - daemon communication pseudo driver
 */

#ifndef _SYS_KDCOM_H_
#define _SYS_KDCOM_H_

typedef union kdcommsg {
	u_int32_t	msg_type;	/* All message types start with this */
	struct rashmsg	rash_msg;
} kdcommsg_t;

#define KDCMESSAGE_SIZE ( sizeof(union kdcommsg) )

#define KDCIOCTL_LOOP_OUT2IN    _IOW('k', 127, dev_t)
#define KDCIOCTL_LOOP_IN2OUT    _IOW('k', 126, dev_t)

#ifdef	_KERNEL

struct kdcom {
	SIMPLEQ_ENTRY(kdcom)	kc_list;
	union kdcommsg 		kc_message;
};

struct kdchead {
/*	qsema_t	kch_lock; */
	int	kch_wait;
	int	kch_open;
	SIMPLEQ_HEAD(kdqhead, kdcom) kdqh;
	struct	selinfo	kch_selinfo;
};

/* kc_open flags, see sys/file.h  */

int	kdcput	__P((int, union kdcommsg *));
int	kdcget	__P((int, union kdcommsg *, int));

  
/*
extern int nkdcom;
extern int nkdcbuf;
*/

#endif	/* _KERNEL */
#endif /* _SYS_KDCOM_H_ */
