/*
 * this is the main include file for all RASH code
 *
 * requires <sys/types.h>
 *
 * $Source: /Volumes/TempStorage/repos/netbsd/othersrc/nastore/kern/dmfs/rash.h,v $
 */

#ifndef _RASH_H_
#define _RASH_H_

#include <sys/types.h>
#include <sys/mount.h>

typedef	struct bfid { u_char bfid[16]; } bfid_t;	/* bfid type */

/*
 * Structure for a message from the kernel to the rash daemons.
 */
struct rashmsg {
	u_int32_t	rm_type;	/* message type */
	u_int32_t	rm_sequence;	/* sequence # of message */
	fhandle_t	rm_fh;
	bfid_t		rm_bfid;
	u_int32_t	rm_dbuid;
	uid_t		rm_uid;		/* uid of user making request */
};

typedef struct rashstat {
	bfid_t		st_bfid;
	off_t		st_bbarrier;
	u_int32_t	st_rashflg;
	u_int32_t	st_dbuid;
} rashstat_t;

struct rashinfo {
        long open_read;         /* open for read */
        long open_write;        /* open for write */
        long open_trunc;        /* open with truncate */
        long unlink;            /* unlinks on archived file */
        long read_rip;          /* read blocked by RIP */
        long write_rip;         /* write blocked by RIP */
        long dirty;             /* file marked dirty */
        long rdwt_fail;         /* access after restore failed */
        long close_rip;         /* close blocked by RIP */
	long rashwrite;		/* number of calls to special rashwrite func */
};

/* Kernel to RASH Daemon commands */
#define RASHD 0                 /*minor device to use in kdcom */
enum rashdcom {
	RASH_RESTORE,	/* begin restore of a file */
	RASH_OBSOLETE	/* mark archived copy obsolete */
};

#endif /* !_RASH_H_ */
