/* $NetBSD: lkminit_cdev.c,v 1.1.1.1 2000/02/28 02:18:00 wrstuden Exp $ */

/*-
 * Copyright (c) 1996 The NetBSD Foundation, Inc.
 * All rights reserved.
 *
 * This code is derived from software contributed to The NetBSD Foundation
 * by Michael Graff <explorer@flame.com>.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
 * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

#include <sys/param.h>
#include <sys/ioctl.h>
#include <sys/systm.h>
#include <sys/conf.h>
#include <sys/mount.h>
#include <sys/exec.h>
#include <sys/lkm.h>
#include <sys/file.h>
#include <sys/errno.h>

/*
 * This is the cdevsw table for the device in question.
 */
cdev_decl(kdc_);

struct cdevsw kdc_cdevsw = {kdc_open, kdc_close, kdc_read, kdc_write,
				kdc_ioctl, (dev_type_stop((*))) enodev, 0,
				kdc_poll, (dev_type_mmap((*))) enodev};

/*
 * declare the filesystem
 */
MOD_DEV("kdc", LM_DT_CHAR, -1, &kdc_cdevsw);

int	kdc_lkmentry	__P((struct lkm_table *, int, int));

int	kdc_lkmload	__P((struct lkm_table *, int));
int	kdc_lkmunload	__P((struct lkm_table *, int));

void	kdcattach	__P((int));
int	kdcdetach	__P((void));

/*
 * entry point
 */
int
kdc_lkmentry(lkmtp, cmd, ver)
	struct lkm_table *lkmtp;	
	int cmd;
	int ver;
{

	DISPATCH(lkmtp, cmd, ver, kdc_lkmload, kdc_lkmunload, lkm_nofunc)
}

/*
 * load routine - call attach routine
 */
int
kdc_lkmload(lkmtp, cmd)
	struct lkm_table *lkmtp;	
	int cmd;
{
	kdcattach(2);
	return (0);
}

/*
 * unload routine - call detach routine
 */
int
kdc_lkmunload(lkmtp, cmd)
	struct lkm_table *lkmtp;	
	int cmd;
{
	return (kdcdetach());
}
