#include <dba.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/time.h>
#define MAXDATE 80

int main()
{
  DbA* db;
  DBAREC val;
  char date[MAXDATE];
  char date1[80] = "1997-09-23 10:13:01";
  char date1b[80] = "1997-09-23 10:33:01";
  char date2[80] = "1997-09-24 10:13:01";
  char date2b[80] = "1997-09-24 10:33:01";
  char t1[] = "a123_1234567";
  int row;
  char value[1024];
  char alph1[] = "abcde";
  char alph2[] ="ABCDEFG";
  char alph3[] = "ZYXWVUTSRQPONMLKJIHGFEDCBAzyxwvutsrqponmlkjihgfedcba";
  int val_size = 1024;

  /*open char value_type table */

  if((db= newDbAbstractor("tmp_ch_functions", 'd', 'c')) == NULL){
    fprintf(stderr, 
	    "Error opening tmp_ch_functions table (character string)\n");
    exit(1);
  }
  DBARECINIT(val);
  
  val.date = &date1;
  val.start_date = &date1b;
  val.value = &alph1;
  val.tag = t1;

  /* test dba_store character string values*/
  if((dba_store(db, &val)) != 0){
    fprintf(stderr, 
	    "Error storing date = %s, value = %s, start_date = %s, process_id = %s\n",
            date1, alph1, date1b, t1);
    dba_destroy(db);
    exit(1);
  }
  val.date = &date2;
  val.start_date = &date2b;
  val.value = &alph2;

  if((dba_store(db, &val)) != 0){
    fprintf(stderr, 
	    "Error storing date = %s, value = %s, start_date = %s, process_id = %s\n",
            date2, alph2, date2b, t1);
    dba_destroy(db);
    exit(1);
  }
  val.value = &alph3;

  if((dba_store(db, &val)) != 0){
    fprintf(stderr, 
	    "Error storing date = %s, value = %s, start_date = %s, process_id = %s\n",
            date2, alph3, date2b, t1);
    dba_destroy(db);
    exit(1);
  }
  DBARECINIT(val);
  val.value = &alph3;
  val.date = &date1;
  val.value_size = val_size;
  val.tag = t1;
  /*test dba_fetch */
  if(dba_fetch(db, &val, &row) != 0){
    fprintf(stderr, "error fetching value with dba_fetch\n");
    dba_destroy(db);
    exit(1);
  }
  strcpy((char*)value, val.value);
  if(strcmp(value, alph1) != 0){
    fprintf(stderr, "error dba_fetched value different\n");
    fprintf(stderr, "dba_fetch\nstore_value=%s\nretrieved_value=%s\n\n",
	    alph1, value);
  }
  val.date = &date2;
  /*test dba_fetch */
  if(dba_fetch(db, &val, &row) != 0){
    fprintf(stderr, "error fetching value with dba_fetch\n");
    dba_destroy(db);
    exit(1);
  }
  strcpy((char*)value, val.value);
  if((strcmp(value, alph2) != 0) && (strcmp(value, alph3) != 0)){
    fprintf(stderr, "error dba_fetched value different\n");
    fprintf(stderr, "dba_fetch(same date)\nstore_value=%s\nretrieved_value=%s\n\n",
	    alph2, value);
  }
  /*test dba_next after dba_fetch */
  val.date_size = 80;
  if(dba_next(db, &val) != 0){
    fprintf(stderr, "error fetching next value after dba_fetch\n");
    dba_destroy(db);
    exit(1);
  }
  strcpy((char*)value, val.value);
  if((strcmp(value, alph3) != 0) && (strcmp(value, alph2) != 0)){
    fprintf(stderr, "error values different (dba_next after dba_fetch)\n");
    fprintf(stderr, "dba_next\nstore_value=%s\nretrieved_value=%s\n\n",
	    alph3, value);
  }

  /*test dba_first*/
  if(dba_first(db, &val, &row) != 0){
    fprintf(stderr, "error fetching dba_first value\n");
    dba_destroy(db);
    exit(1);
  }
  strcpy((char*)value, val.value);
  if(strcmp(value, alph1) != 0){
    fprintf(stderr, "error fetched first value different\n");
    fprintf(stderr, "dba_first\nstore_value=%s\nretrieved_value=%s\n\n",
	    alph1, value);
  }

  /* test dba_next after dba_first*/
  if(dba_next(db, &val) != 0){
    fprintf(stderr, "error fetching next value after dba_first\n");
    dba_destroy(db);
    exit(1);
  }
  strcpy((char*)value, val.value);
  strcpy((char*)date, val.date);
  if(strcmp(value, alph2) != 0){
    fprintf(stderr, "error values different (dba_next after dba_first)\n");
    fprintf(stderr, "dba_next\nstore_value=%s\nretrieved_value=%s\n",
	    alph2, value);
    fprintf(stderr, "store_date=%s\nretrieved_date=%s\n\n",
	    date2, date);
  }
  /* second test of dba_next after dba_first*/
  if(dba_next(db, &val) != 0){
    fprintf(stderr, "error fetching second next value after dba_first\n");
    dba_destroy(db);
    exit(1);
  }
  strcpy((char*)value, val.value);
  strcpy((char*)date, val.date);
  if(strcmp(value, alph3) != 0){
    fprintf(stderr, "error values different (dba_next after dba_first)\n");
    fprintf(stderr, "second dba_next\nstore_value=%s\nretrieved_value=%s\n",
	    alph3, value);
    fprintf(stderr, "store_date=%s\nretrieved_date=%s\n\n",
	    date2, date);
  }

  /*test dba_last*/
  if(dba_last(db, &val, &row) != 0){
    fprintf(stderr, "error fetching dba_last value\n");
    dba_destroy(db);
    exit(1);
  }
  strcpy((char*)value, val.value);
  if(strcmp(value, alph2) != 0){
    fprintf(stderr, "error fetching dba_last value \n");
    fprintf(stderr, "dba_last\nstore_value=%s\nretrieved_value=%s\n\n",
	    alph2, value);
  }
  /* test dba_next after dba_last*/
  if(dba_next(db, &val) != 0){
    fprintf(stderr, "error fetching next value after dba_last\n");
    dba_destroy(db);
    exit(1);
  }
  strcpy((char*)value, val.value);
  if(strcmp(value,alph3) != 0){
    fprintf(stderr, "error values different (dba_next after dba_last)\n");
    fprintf(stderr, "dba_next\nstore_value=%s\nretrieved_value=%s\n\n",
	    alph3, value);
  }

  /* not in the api, don't use*/
  if(dba_remove(db) != DBA_SUCCESS)
    fprintf(stderr, "error removing table from database\n");

  dba_destroy(db);
  return(0);
}











