#include <dba.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/time.h>
#define MAXDATE 80

int main()
{
  DbA* db;
  DBAREC val;
  char date[MAXDATE];
  char date1[] = "1997-09-23 10:13:01";
  char date1b[] = "1998-09-23 10:33:01";
  char date2[] = "1997-10-24 10:13:01";
  char date2b[] = "1998-10-24 10:33:01";
  int row;
  double value;
  double value1 = 1111.111;
  double value2 = 2222.222;
  double value2a = 2121.212;
  double value3 = 3333.333;
  int val_size = 8;
  
  DBARECINIT(val);

  /*open float value_type table */
  if((db= newDbAbstractor("tmp_fl_functions", 'd', 'f')) == NULL){
    fprintf(stderr, "Error opening tmp_fl_functions table (float)\n"); 
    exit(1);
  }
  val.date = &date1;
  val.start_date = &date1b;
  val.value = &value1;
  /* test dba_store float values*/

  if((dba_store(db, &val)) != 0){
    fprintf(stderr, 
	    "Error storing date = %s, value = %f, start_date = %s\n",
            date1, value1, date1b);
    dba_destroy(db);
    exit(1);
  }
  val.value = &value2a;
  val.start_date = &date2b;
  if((dba_store(db, &val)) != 0){
    fprintf(stderr, 
	    "Error storing date = %s, value = %f, start_date = %s\n",
	    date1, value2, date2b);
    dba_destroy(db);
    exit(1);
  }
  val.date = &date2;
  val.start_date = &date2b;
  val.value = &value2;

  if((dba_store(db, &val)) != 0){
    fprintf(stderr, 
	    "Error storing date = %s, value = %f, start_date = %s\n",
            date2, value2, date2b);
    dba_destroy(db);
    exit(1);
  }
  val.value = &value3;

  if((dba_store(db, &val)) != 0){
    fprintf(stderr, 
	    "Error storing date = %s, value = %f, start_date = %s\n",
            date2, value3, date2b);
    dba_destroy(db);
    exit(1);
  }
  DBARECINIT(val);
  val.value_size = val_size;
  val.date = date2;
  val.value = &value;

  /*test dba_fetch */
  if(dba_fetch(db, &val, &row) != 0){
    fprintf(stderr, "error fetching value with dba_fetch\n");
    dba_destroy(db);
    exit(1);
  }
  value = *((double *)val.value);
  
  if((value != value3)  && (value != value2)){
    fprintf(stderr, "error dba_fetched value different\n");
    fprintf(stderr, "dba_fetch\nstore_value=%f and %f\nretrieved_value=%f\n\n",
	    value2, value3, value);
  }
  val.date_size = MAXDATE;
  /*test dba_next after dba_fetch */
  if(dba_next(db, &val) != 0){
    fprintf(stderr, "error fetching next value after dba_fetch\n");
    dba_destroy(db);
    exit(1);
  }
  value = *((double *)val.value);
  if((value != value3)  && (value != value2)){
    fprintf(stderr, "error values different (dba_next after dba_fetch)\n");
    fprintf(stderr, "dba_next\nstore_value=%f\nretrieved_value=%f\n\n",
	    value3, value);
  }
  val.date = date1;

  /*test dba_first*/
  if(dba_first(db, &val, &row) != 0){
    fprintf(stderr, "error fetching dba_first value\n");
    dba_destroy(db);
    exit(1);
  }
  value = *((double *)val.value);
  if(value != value1){
    fprintf(stderr, "error fetched first value different\n");
    fprintf(stderr, "dba_first\nstore_value=%f\nretrieved_value=%f\n\n",
	    value1, value);
  }

  val.date = &date;

  /* test dba_next after dba_first*/
  if(dba_next(db, &val) != 0){
    fprintf(stderr, "error fetching next value after dba_first\n");
    dba_destroy(db);
    exit(1);
  }

  value = *((double *)val.value);
  strcpy((char*)date, val.date);
  if(value != value2a){
    fprintf(stderr, "error values different (dba_next after dba_first)\n");
    fprintf(stderr, "dba_next\nstore_value=%f\nretrieved_value=%f\n",
	    value2, value);
    fprintf(stderr, "store_date=%s\nretrieved_date=%s\n\n",
	    date2, date);
  }
  
  /*test dba_last*/
  if(dba_last(db, &val, &row) != 0){
    fprintf(stderr, "error fetching dba_last value\n");
    dba_destroy(db);
    exit(1);
  }

  value = *((double *)val.value);
  strcpy((char*)date, val.date);

  if((value != value3) && (value != value2)){
    fprintf(stderr, "error fetching test dba_last value\n");
    fprintf(stderr, "dba_last\nstore_value=%f\nretrieved_value=%f\n\n",
	    value2, value);
  }
  
  /* test dba_next after dba_last*/
  if(dba_next(db, &val) != 0){
    fprintf(stderr, "error fetching next value after dba_last\n");
    dba_destroy(db);
    exit(1);
  } 
  value = *((double *)val.value);
  strcpy((char*)date, val.date);

  if((value != value3) && (value != value2)){
    fprintf(stderr, "error values different (dba_next after dba_last)\n");
    fprintf(stderr, "dba_next\nstore_value=%f\nretrieved_value=%f\n\n",
	    value3, value);
  }

  /* not in the api, don't use*/
  if(dba_remove(db)!= DBA_SUCCESS)
    fprintf(stderr, "error removing table from database\n");

  dba_destroy(db);
  return(0);
}

