#include <dba.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/time.h>

#define MAXDATE 80


int main()
{
  DbA* db;
  DBAREC val;
  int row;
  long int value;
  long int date;

  long int date1 = 877621111; 
  long int date2 = 877622222;
  long int value1 = 100000000;
  long int value2 = 200000000;
  long int value3 = 300000000;

  if((db= newDbAbstractor("tmp_int_functions", 't', 'i')) == NULL){
    fprintf(stderr, "Error opening tmp_int_func table (integer value)\n");  
    exit(1);
  }

  val.date = &date1; 
  val.value = &value1;
  val.subset = "foo";

  /* test dba_store integer values*/
  if((dba_store(db, &val)) != 0){
    fprintf(stderr, "Error with first dba_store\n");
    dba_destroy(db);
    exit(1);
  }

  val.date = &date2;
  val.value = &value2;

  if((dba_store(db, &val)) != 0){ 
    fprintf(stderr,"Error with second dba_store\n");
    dba_destroy(db);
    exit(1);
  }

  val.value = &value3;

  if((dba_store(db, &val)) != 0){ 
    fprintf(stderr, "Error with third dba_store\n");
    dba_destroy(db);
    exit(1);
  }

  val.value_size = 4;

  /*test dba_fetch */
  if(dba_fetch(db, &val, &row) != 0){
    fprintf(stderr, "error fetching value with dba_fetch\n");
    dba_destroy(db);
    exit(1);
  }
  value = *((int*)val.value);
  if(!((value == value2) || (value == value3))){
    fprintf(stderr, "error dba_fetched value different\n");
    fprintf(stderr, "dba_fetch\nstore_value=%ld\nretrieved_value=%ld\n\n",
            value2, value);
  }
  val.date_size = 4;
  /*test dba_next after dba_fetch */

  if(dba_next(db, &val) != 0){
    fprintf(stderr, "error fetching next value after dba_fetch\n");
    dba_destroy(db);
    exit(1);
  }
  value = *((int*)val.value);
  if(value != value3){
    fprintf(stderr, "error values different (dba_next after dba_fetch)\n");
    fprintf(stderr, "dba_next\nstore_value=%ld\nretrieved_value=%ld\n\n",
            value3, value);
  }

  /*test dba_first*/
  if(dba_first(db, &val, &row) != 0){
    fprintf(stderr, "error fetching dba_first value\n");
    dba_destroy(db);
    exit(1);
  }
  value = *((int*)val.value);
  if(value != value1){
    fprintf(stderr, "error fetched first value different\n");
    fprintf(stderr, "dba_first\nstore_value=%ld\nretrieved_value=%ld\n\n",
            value1, value);
  }
  /* test dba_next after dba_first*/
  if(dba_next(db, &val) != 0){
    fprintf(stderr, "error fetching next value after dba_first\n");
    dba_destroy(db);
    exit(1);
  }

  value = *((int*)val.value);
  date = *((int*)val.date);
  if(value != value2){
    fprintf(stderr, "error values different (dba_next after dba_first)\n");
    fprintf(stderr,
            "dba_next\nstore_value=%ld\nretrieved_value=%ld\nstore_date=%ld\nretrieved_date=%ld\n\n",
            value2, value, date2, date);
  }
  /* second test dba_next after dba_first*/
  if(dba_next(db, &val) != 0){
    fprintf(stderr, "error fetching second next value after dba_first\n");
    dba_destroy(db);
    exit(1);
  }
  value = *((int*)val.value);
  date = *((int*)val.date);
  if(value != value3){
    fprintf(stderr, "error values different (dba_next after dba_first)\n");
    fprintf(stderr, "second dba_next\nstore_value=%ld\nretrieved_value=%ld\n",
            value3, value);
    fprintf(stderr, "store_date=%ld\nretrieved_date=%ld\n\n",
            date2, date);
  }

  /*test dba_last*/
  if(dba_last(db, &val, &row) != 0){
    fprintf(stderr, "error fetching dba_last value\n");
    dba_destroy(db);
    exit(1);
  }

  value = *((int*)val.value);
  date = *((int*)val.date);
  if(value != value2){
    fprintf(stderr, "error fetching dba_last value(second dba_last called)\n");    fprintf(stderr, "dba_last\nstore_value=%ld\nretrieved_value=%ld\n\n",
            value2, value);
  }

  /* test dba_next after dba_last*/
  if(dba_next(db, &val) != 0){
    fprintf(stderr, "error fetching next value after dba_last\n");
    dba_destroy(db);
    exit(1);
  }
  value = *((int*)val.value);
  date = *((int*)val.date);
  if(value != value3){
    fprintf(stderr, "error values different (dba_next after dba_last)\n");
    fprintf(stderr, "dba_next\nstore_value=%ld\nretrieved_value=%ld\n\n",
            value3, value);
  }
  /* not in the api, don't use*/
  if(dba_remove(db)!= DBA_SUCCESS)
    fprintf(stderr, "error removing table from database\n");
  

  dba_destroy(db);
  return(0);
}














