#include <dba.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/time.h>

int main()
{
  DbA* db;
  DBAREC val;
  char date1[] = "1997-09-23 10:13:01";
  char date1a[] = "1997-09-23 10:25:01";
  char date2[] = "1997-09-24 10:13:01";
  char date2a[] = "1997-09-24 10:19:01";
  char sub_set[] = "333d_798435";
  int row;
  long int value;
  long int value1 = 1000000;
  long int value2 = 2000000;
  long int value3 = 3000000;
  long int value4 = 4000000;
  long int value5 = 5000000;
  int val_size = 4;
  int date_size = 80;
  
  /*open integer value_type table */
  if((db= newDbAbstractor("tmp_int_update", 'd', 'i')) == NULL){
    fprintf(stderr, "Error opening tmp_int_update table (integer value)\n");
    exit(1);
  }

  DBARECINIT(val);

  val.date = &date1; 
  val.start_date = &date1a;
  val.value = &value1;
  /* test dba_store integer values*/
  if((dba_store(db, &val)) != 0){
    fprintf(stderr, 
	    "Error storing date = %s, value = %ld, start date = %s\n",
            date1, value1, date1a);
    dba_destroy(db);
    exit(1);
  }
  val.subset = &sub_set;
  if((dba_store(db, &val)) != 0){
    fprintf(stderr, 
	    "Error storing date = %s, value = %ld, start date = %s, id = %s\n",
            date1, value1, date1a, sub_set);
    dba_destroy(db);
    exit(1);
  }
  val.date = &date2; 
  val.start_date = &date2a;
  val.value = &value2;
  if((dba_store(db, &val)) != 0){
    fprintf(stderr, 
	    "Error storing date = %s, value = %ld, start date = %s, id = %s\n",
            date2, value2, date2a, sub_set);
    dba_destroy(db);
    exit(1);
  }
  val.value = &value3;
  if((dba_store(db, &val)) != 0){
    fprintf(stderr, 
	    "Error storing date = %s, value = %ld, start date = %s, id = %s\n",
            date2, value3, date2a, sub_set);
    dba_destroy(db);
    exit(1);
  }

  DBARECINIT(val);
  val.date = &date1;
  val.date_size = date_size;
  val.value = &value;
  val.value_size = val_size;

  /*test dba_update for one value for date */
  /*test dba_fetch */
  if(dba_fetch(db, &val, &row) != 0){
    fprintf(stderr, "error fetching value with dba_fetch\n");
    dba_destroy(db);
    exit(1);
  }
  value = *((int*)val.value);
  if(!(value == value1)){
    fprintf(stderr, "error dba_fetched value different\n");
    fprintf(stderr, "dba_fetch\nstore_value=%ld\nretrieved_value=%ld\n\n",
	    value1, value);
  }
  /*test dba_update*/
  if(dba_update(db, &val, &value4) != 0){
    fprintf(stderr, "error updating value with dba_update\n");
    dba_destroy(db);
    exit(1);
   }
  DBARECINIT(val);
  val.date = &date1;
  val.date_size = date_size;
  val.value = &value;
  val.value_size = val_size;

  /* check dba_update */
  /* fetch updated value */
  if(dba_fetch(db, &val, &row) != 0){
    fprintf(stderr, "error fetching value with dba_fetch after dba_update\n");
    dba_destroy(db);
    exit(1);
  }
  value = *((int*)val.value);
  /*check if updated value is correct */
  if((value != value4)){
    fprintf(stderr, "error dba_fetched value different\n");
    fprintf(stderr, 
	    "dba_fetch after dba_update\nstore_value=%ld\nretrieved_value=%ld\n\nrows = %d\n",
	    value4, value, row); 
  }
  val.subset = &sub_set;
  val.date = &date2;
  /* test update when there are two entries for same date */
  if(dba_fetch(db, &val, &row) != 0){
    fprintf(stderr, "error fetching value with dba_fetch\n");
    dba_destroy(db);
    exit(1);
  }
   value = *((int*)val.value);
  if((!(value == value2)) && (!(value == value3))){
    fprintf(stderr, "error dba_fetched value different\n");
    fprintf(stderr, 
	    "dba_fetch\nstore_value=%ld or %ld\nretrieved_value=%ld\n\n",
            value2, value3, value);
  }
  /*test dba_update*/
  else{
    val.value = &value3;
    if(dba_update(db, &val, &value5) != 0){
      fprintf(stderr, "error updating value with dba_update\n");
      dba_destroy(db);
      exit(1);
    }

    /* check dba_update */
    /* fetch updated value */
    if(dba_fetch(db, &val, &row) != 0){
      fprintf(stderr, "error fetching value with dba_fetch after dba_update\n");
      dba_destroy(db);
      exit(1);
    }
    value = *((int*)val.value);
    /*check updated value correct */
    if((!(value == value5)) && (!(value == value2))){
      fprintf(stderr, "error dba_fetched value different\n");
      fprintf(stderr, 
	      "dba_fetch\nstore_value=%ld or %ld\nupdated_value=%ld\nretrieved_value=%ld\n\n",
	      value2, value3, value5, value);
    }
    /* fetch un-updated value */
    val.value_size = val_size;
    if(dba_next(db, &val) != 0){
      fprintf(stderr, 
	      "error fetching value with dba_next  after dba_update\n");
      dba_destroy(db);
      exit(1);
    }
    value = *((int*)val.value);
    /*check un-updated value correct */
    if((!(value == value5)) && (!(value == value2))){
      fprintf(stderr, "error dba_fetched value different\n");
      fprintf(stderr, 
	      "dba_next\nstore_value=%ld or %ld\nupdated_value=%ld\nretrieved_value=%ld\n\n",
	      value2, value3, value5, value);
    }
  }
  /* not in the api, don't use*/
  if(dba_remove(db) != DBA_SUCCESS)
    fprintf(stderr, "error removing table from database\n");

  dba_destroy(db);
  return(0);
}






