#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/time.h>

#include <libpq-fe.h> 



int main(int argc, char** argv)
{
  char* backend_host = "gnome.nas.nasa.gov";
  char buffer[256];

  PGconn* db; 
  PGresult* res; 
  int c;
  char* p;

  if(argc < 1){
    fprintf(stderr, "usage: pgbench dbname\n");
    exit(1);
  }

  db = PQsetdb(backend_host, NULL, NULL, NULL, argv[1]);


  if (PQstatus(db) == CONNECTION_BAD) { 
    fprintf(stderr,"Connection to database '%s' failed.\n", argv[1]); 
    fprintf(stderr,"%s", PQerrorMessage(db)); 
    PQfinish(db);
    return(1); 
  }


  res = PQexec(db, "CREATE TABLE tmp_test_char (value char)");
  if (PQresultStatus(res) != PGRES_COMMAND_OK) { 
    fprintf(stderr,"CREATE command failed\n"); 
    PQclear(res); 
    PQfinish(db);
    exit(1);
  }
  PQclear(res);

  sprintf(buffer, "INSERT INTO tmp_test_char VALUES ('%c')", 'U');
  res = PQexec(db, buffer);
  if (PQresultStatus(res) != PGRES_COMMAND_OK) { 
    fprintf(stderr,"INSERT command failed\n"); 
    PQclear(res); 
    res = PQexec(db, "drop table tmp_test_char");
    PQclear(res); 
    PQfinish(db);
    exit(1);
  }
  PQclear(res);
  res = PQexec(db, "select value from tmp_test_char");
  if (PQresultStatus(res) != PGRES_TUPLES_OK) { 
    fprintf(stderr,"SELECT command failed\n"); 
    printf("%s\n", PQerrorMessage(db));
    PQclear(res); 
    PQfinish(db);
    exit(1);
  }
  
  p = PQgetvalue(res, 0, 0);
  c = p[0];
  if(c != 'U')
    fprintf(stderr,"error converting result\n");

  PQclear(res);

  res = PQexec(db, "DROP TABLE tmp_test_char");
  if (PQresultStatus(res) != PGRES_COMMAND_OK) { 
    fprintf(stderr,"DROP TABLE command failed\n"); 
    PQclear(res); 
    PQfinish(db);
    exit(1);
  }
  PQclear(res);
  PQfinish(db);

  exit(0);
}
