#include <unistd.h>
#include <stdlib.h>
#include <time.h>
#include <sys/time.h>


main(int argc, char** argv)
{
  time_t now;
  time_t mktime_ret;
  time_t mktime_null_ret;
  int i;
  int minuteswest;
  int loopcnt;
  struct timezone zone;
  struct timeval start, end;
  struct tm *mktimein;
  double seconds = 0;

  loopcnt = atoi(argv[1]);
  time(&now);

  gettimeofday(&start, &zone);
  for(i = 0; i < loopcnt; i++){
    mktimein = localtime(&now);
    now++;
  }
  gettimeofday(&end, &zone);

  seconds += (1.0 * end.tv_usec) / 1000000;
  seconds += end.tv_sec;
  seconds -= start.tv_sec;
  seconds -= (1.0 * start.tv_usec) / 1000000;

  printf("localtime, %d calls in %lf seconds\n", loopcnt, seconds);

  seconds = 0;

  gettimeofday(&start, &zone);
  for(i = 0; i < loopcnt; i++){
    ctime(&now);
    now++;
  }
  gettimeofday(&end, &zone);

  seconds += (1.0 * end.tv_usec) / 1000000;
  seconds += end.tv_sec;
  seconds -= start.tv_sec;
  seconds -= (1.0 * start.tv_usec) / 1000000;

  printf("ctime, %d calls in %lf seconds\n", loopcnt, seconds);

  seconds = 0;


  gettimeofday(&start, &zone);
  for(i = 0; i < loopcnt; i++){
    mktime_ret = mktime(mktimein);
  }
  gettimeofday(&end, &zone);

  seconds += (1.0 * end.tv_usec) / 1000000;
  seconds += end.tv_sec;
  seconds -= start.tv_sec;
  seconds -= (1.0 * start.tv_usec) / 1000000;

  printf("mktime, %d calls in %lf seconds\n", loopcnt, seconds);

  seconds = 0;

  minuteswest = zone.tz_minuteswest;

#ifdef __convex__
  setenv("TZ", "", 1);
#else
  putenv("TZ=");
#endif

  gettimeofday(&start, &zone);
  for(i = 0; i < loopcnt; i++){
    mktime_null_ret = mktime(mktimein);
  }
  gettimeofday(&end, &zone);

  seconds += (1.0 * end.tv_usec) / 1000000;
  seconds += end.tv_sec;
  seconds -= start.tv_sec;
  seconds -= (1.0 * start.tv_usec) / 1000000;

  printf("mktime w/ TZ=NULL, %d calls in %lf seconds\n", loopcnt, seconds);

  printf("difference using TZ=NULL is %ld, offset from gettimeofday is %d\n",
	mktime_ret -  mktime_null_ret, minuteswest);

}


