#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdio.h>

#include <string.h>
#include <ndbm.h>

#define SYSNAMEMAX 20
#define DATELEN 7
#define LONGLEN 16
#define LLONGLEN 32

#ifndef min
#define        min(a,b) (((a)<(b))?(a):(b))
#endif

#define DBDIR "/usr/mss/lib/usr/mss/metrics/DB"
DBM *db;

int init_dbs(char* pathname)
{
  int i;

  if(( db  = dbm_open(pathname, O_RDWR|O_CREAT, 0644)) == NULL){
    fprintf(stderr, "An error occurred opening db %s\n", pathname);
    exit(1);
  }
  return(0);

}


void close_dbs()
{
  int i;
  dbm_close(db);

}

 


main(int argc, char** argv)
{
  datum target;

  if(argc != 3){
    fprintf(stderr, "usage: delete_dbm database_path/dbname key\n");
    exit(1);
  }
  else if(init_dbs(argv[1]))
    exit(1);

  target.dptr = argv[2];
  target.dsize = strlen(target.dptr);
  
  if(dbm_delete(db, target) < 0)
    dbm_error(db);
  
  
  close_dbs();
  exit(0);
}
  
  
