#ifndef _GLOBALS_H

#include <sys/types.h>
#include <msscompat.h>
#include <limits.h>

#ifndef MB
#define MB (1024 * 1000)
#endif

#ifndef LONG_LONG_MAX

#if defined(__netbsd__)

#include <machine/limits.h>
#define LONG_LONG_MAX QUAD_MAX

#else

#define LONG_LONG_MAX 0x7fffffffffffffffLL

#endif

#endif


struct _controls{
  int histogram;
  int verbose;
  int overwrite;
  int metricdb;
  int yesterday;
  char *date;
  time_t newer_than; 
  time_t older_than;
};


#ifndef INSIDE_GLOBALS_C
/***************************** globals *****************************/

extern OFF_T total_bytes;
extern OFF_T files;

extern OFF_T files_time;
extern OFF_T bytes_created;
extern OFF_T files_created;
extern OFF_T bytes_accessed;
extern OFF_T files_accessed;


extern OFF_T resident_bytes;
extern OFF_T resident_files;
extern OFF_T archived_files;
extern OFF_T archived_bytes;


/* histogram stuff */
extern OFF_T xvals[];
extern int intervals;

extern OFF_T timetotal[];
extern OFF_T tipoints[];

extern OFF_T xtotal[];
extern OFF_T points[];

extern OFF_T axtotal[];
extern OFF_T apoints[];

extern OFF_T txtotal[];
extern OFF_T tpoints[];

extern struct _controls controls;

#endif  /* INSIDE_GLOBALS_C */

#define _GLOBALS_H
#endif /* GLOBALS */






