#ifndef DBA_H
#define DBA_H

#include <sys/types.h>
#include <_dba_impl.h>

#ifndef DBA_MAX_CHARARRAY
#define DBA_MAX_CHARARRAY 4096
#endif

#ifndef DBARECINIT
#include <string.h>
#define DBARECINIT(a) memset(&a, 0, sizeof(DBAREC))
#endif

/* this is what people pass to us that contains the data to be saved */
/********this is defined in _dba_impl.h *************************
typedef struct _DBAREC {
  void* date;
  int date_size;
  void* value;
  int value_size;
  void* start_date;
  void* subset;
  void* tag;
} DBAREC; 
*********** but is here for informational purposes **************/


struct _DBA{
  /* this hides all internal stuff. Don't mess with it or it's contents */
  DbA_impl *_impl;
};

typedef struct _DBA DbA;

/********this is defined in _dba_impl.h *************************
struct _DBA_Info{
  char description[80];
  char data_units[20];
};

typedef struct _DBA_Info DbA_Info;
*********** but is here for informational purposes **************/



/* these are external */
/* return DBA_SUCESS on success, else failure */

/*int dba_fetch(DbA* dba, void* date, void* value, 
	      int value_size, int* rows); */

int dba_fetch(DbA* dba, DBAREC* rec, int* rows);

/* int dba_store(DbA* dba, void* date, void* value, void* start_date, 
	      char* process_id); */

int dba_store(DbA* dba, DBAREC* rec);

/* int dba_first(DbA* dba, void* date, int date_size, 
	      void* value, int value_size, int* rows); */

int dba_first(DbA* dba, DBAREC* rec, int* rows);

/* int dba_last(DbA* dba, void* date, int date_size,
              void* value, int value_size, int* rows); */

int dba_last(DbA* dba, DBAREC* rec, int* rows);


/* int dba_next(DbA* dba, void* date, int date_size,
	     void* value, int value_size); */

int dba_next(DbA* dba, DBAREC* rec);

/* int dba_update(DbA* dba, void* date, void* old_value, void* new_value); */

int dba_update(DbA* dba, DBAREC* rec, void* new_value); 

int dba_remove(DbA* dba);

DbA* newDbAbstractor(char* tablename, int date_type, int value_type);

int dba_set_info(DbA* dba, DbA_Info* info);
int dba_get_info(DbA* dba, DbA_Info* info);

int dba_begin(DbA* dba);
int dba_end(DbA* dba);

/* void */
void dba_destroy(DbA* dba);


#define DBA_SUCCESS 0
#define DBA_ERROR   1
#define DBA_VTYPE   2
#define DBA_INVARG  4
#define DBA_PERM    8

#define DBA_EBUFFER 16
#endif











