#include <sys/types.h>
#include <msscompat.h>

/* 
   inputs are,  xvals gives endpoints of intervals. xtotal should be intialized
   to zeros on first call, as it adds data to the array element that
   corresponds to the data interval. intervals is the number of intervals.
   i.e. intervals = sizeof xvals array - 1.
   data is the data point to be factored into the existing histogram.
*/

int histogram(OFF_T xvals[], OFF_T xtotal[], OFF_T points[], int intervals, OFF_T data)
{
  int i;
  if(data < xvals[0])
    return(-1);
  
  for( i = 0; i < intervals; ++i){
    if((data >= xvals[i] && data < xvals[i + 1])){
      ++(points[i]);
      xtotal[i] += data;
      return(0);
    }
  }

  return(1);
}

int histogramTNG(OFF_T xvals[], OFF_T xtotal[], OFF_T points[], int intervals, OFF_T size, OFF_T data)
{
  int i;
  if(data < xvals[0])
    return(-1);
  
  for( i = 0; i < intervals; ++i){
    if((size >= xvals[i] && size < xvals[i + 1])){
      ++(points[i]);
      xtotal[i] += data;
      return(0);
    }
  }

  return(1);
}

      








