#include <list.h>

LIST* new_list()
{
  LIST* list; 

  list = (LIST*) malloc(sizeof(LIST));
  list->top = NULL;
  list->bottom = NULL;
  list->current = NULL;
  list->list_length = 0;
  list->_advanced = 0;
  return list;
}


void add_node(LIST* list, NODE* foo)
{
  NODE* cn = list->top;
  if(cn==NULL){
    list->top = foo;
    list->bottom = foo;
    list->current = NULL;
    foo->prev = foo->next = NULL;
  }
  else{
    foo->next=list->top;
    foo->prev = NULL;
    list->top->prev=foo;
    list->top = foo;
  }
  list->_advanced = 0;
  ++(list->list_length);
}


long list_length(LIST* list)
{
  return(list->list_length);
}


NODE* first_node(LIST* list)
{
  list->current = list->top;
  list->_advanced = 0;
  return(list->current);
}

NODE* next_node(LIST* list)
{
  if(list->current == NULL)
    return NULL;
  else if(list->_advanced == 1){
    list->_advanced = 0;
    return(list->current);
  }
  else{
    list->_advanced = 0;
    list->current = list->current->next;
    return list->current;
  }
}

NODE* prev_node(LIST* list)
{
  if(list->current == NULL)
    return NULL;
  else if(list->_advanced == -1){
    list->_advanced = 0;
    return(list->current);
  }
  else{
    list->_advanced = 0;
    list->current = list->current->prev;
    return list->current;
  }
}

NODE* last_node(LIST* list)
{
  list->_advanced = 0;
  list->current = list->bottom; 
  return(list->current);
}

/* remove item from list, does not check pointer, so very bad things will 
   happen if you pass garbage into this. Overhead of checking is too high */

void remove_node(LIST* list, NODE* foo)
{
  if(foo==NULL)
    return;

  list->list_length--;

/*   //what if we are deleting where our current pointer refs? */

  if(foo == list->current){
    if(list->current == list->bottom){
      list->current = list->current->prev;
      list->_advanced =  -1;
    }
    else{
      list->current = list->current->next;
      list->_advanced = 1;
    }
  }

/*   //list of one   */
  if(list->bottom == list->top){
    list->bottom = list->top = NULL;
  }
  
/*   //remove list->top */
  else if(foo == list->top){
    list->top = list->top->next;
    list->top->prev = NULL;
  }
/*   //remove list->bottom */
  else if(foo == list->bottom){
    list->bottom = list->bottom->prev;
    list->bottom->next = NULL;
  }
/*  //node is 'inside' of list, so prev and next must exist */
  else{
    foo->prev->next = foo->next;
    foo->next->prev = foo->prev;
  }
}



















