#include <dba.h>
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>

DbA* newDbAbstractor(char* tablename, int date_type, int value_type)
{
  DbA* dba;
  DbA_impl* impl;
  if((dba = (DbA*)malloc(sizeof(DbA))) == NULL){
    fprintf(stderr, "dba.c: could not allocate memory for dba abstractor!\n");
    return(NULL);
  }
  if((impl = _impl_create(tablename, date_type, value_type)) == NULL){
    free(dba);
    return(NULL);
  }
  impl->_dba_ref = dba;
  dba->_impl = impl;
  return(dba);
}  


/* basically wrappers that call the correct hidden routines */  
int dba_fetch(DbA* dba, DBAREC* rec, int* rows)
{
  return(dba->_impl->fetch(dba->_impl, rec, rows));
}

int dba_first(DbA* dba, DBAREC* rec, int* rows)
{
  return(dba->_impl->first(dba->_impl, rec, rows));
}

int dba_last(DbA* dba, DBAREC* rec, int* rows)
{
  return(dba->_impl->last(dba->_impl, rec, rows));
}

int dba_next(DbA* dba, DBAREC* rec)
{
  return(dba->_impl->next(dba->_impl, rec));
}

int dba_store(DbA* dba, DBAREC* rec)
{
  return(dba->_impl->store(dba->_impl, rec));
}

int dba_update(DbA* dba, DBAREC* rec, void* new_value)
{
  return(dba->_impl->update(dba->_impl, rec, new_value));
}

void dba_destroy(DbA* dba)
{
  dba->_impl->destroy(dba->_impl);
}

int dba_remove(DbA* dba)
{
  return(dba->_impl->remove(dba->_impl));
}

int dba_get_info(DbA* dba, DbA_Info* info)
{
  return(dba->_impl->get_info(dba->_impl, info));
}

int dba_set_info(DbA* dba, DbA_Info* info)
{
  return(dba->_impl->set_info(dba->_impl, info));
}

int dba_begin(DbA* dba)
{
  return(dba->_impl->begin(dba->_impl));
}

int dba_end(DbA* dba)
{
  return(dba->_impl->end(dba->_impl));
}



