#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <dba.h>
#include <time.h>

#define INFO "/usr/ucb/uptime"
int main()
{
  FILE * load_info;

  char linebuf[128];
  char* p;
  double value;
  time_t date;
  DbA* db;
  DBAREC val;

  DBARECINIT(val);
  
  if((load_info = popen(INFO, "r")) == NULL)
    fprintf(stderr, "popen error\n");
  
  if(fgets(linebuf, 128, load_info) != NULL){
     if((p = strtok(linebuf, ".")) == NULL || p[0] == '\0'){
       fprintf(stderr, "loadavg:can not read in line\n");
       exit(1);
     }
     if((p = strtok(NULL, ",")) == NULL){
       fprintf(stderr, "loadavg:can not strtok line\n");
       exit(1);
     }
     if((p = strtok(NULL, ",")) == NULL){
       fprintf(stderr, "loadavg:can not strtok line\n");
       exit(1);
     }
     value = strtod(p, (char **)NULL);
   }
  if(pclose(load_info) == -1)
    fprintf(stderr, "pclose error\n");
  
  time(&date);
  val.date = &date;
  val.subset = "ldavg";
  val.value = &value;

  if((db = newDbAbstractor("sys_load_proc_snap", 't', 'f')) == NULL){
    fprintf(stderr, "Error opening sys_load_proc_snap table\n");
    exit(1);
  }
  if(dba_store(db, &val)!=0){
    fprintf(stderr, "Error storing to sys_load_proc_snap table\n");
    exit(1);
  }
  dba_destroy(db);

  return(0);
}






