/*************************************************************************
  each metric record starts with a key
  the key has the format
  
  RECORDTYPE:JULIANDATE:subtype
  
  where 

  RCORDTYPES are
  
                 HISTOGRAM (data on file size distrib for last 24 hours )
		 FILESTAT  (statistics on filesystem )
		 DATAFLOW  (measurements showing data moved and time spent
		            moving it )

  Juliandate = yydddhh  
  
  and 

  subtypes are 

  
  HISTOGRAM:      mountpoint

  FILESTAT:       mountpoint

  DATAFLOW:       ARCHIVE
                  RESTORE
		  NETIN 
		  NETOUT
  

*************************************************************************/

#define MAXINTERVALS 20
#define RECLABELMAX  36

#define METRICDAT  "/usr/mss/lib/metrics/metrics.dat"
#define METRICIDX  "/usr/mss/lib/metrics/metrics.idx"

#define F_ARCHIVE  0x1
#define F_RESTORE  0x2
#define F_NETIN    0x4
#define F_NETOUT   0x8


struct histogram_rec{
  char record_label[RECLABELMAX];
  int intervals;
  OFF_T bounds[MAXINTERVALS + 1];
  OFF_T xavg[MAXINTERVALS];
  float xpercent[MAXINTERVALS];
}

struct dataflow_rec{
  char record_label[RECLABELMAX];
  OFF_T blocks;
  OFF_T bytes;
  time_t walltime;
}

struct files_rec{
  char record_label[RECLABELMAX];
  OFF_T files;
  OFF_T data;
  OFF_T arc_files;
  OFF_T arc_data;
  OFF_T arc_res_files;
  OFF_T arc_res_data;
}


typedef struct metrics_db{
  IX_DESC idx;
  ENTRY   e;
  FILE* fp;
  int fd;
  char buffer[64 * 1024];
}METRICDB;



