#include <stdlib.h>
#include <stdio.h>
#include <math.h>

#include <list.h>

extern void realfft (double *in, unsigned  n, double * out);


int main(int argc, char** argv)
{
  int n, i;
  double* datain;
  double* dataout;
  double totalP=0.0;
  double totalA = 0.0;
  double psd;
  char buffer[1024];
  LIST* list;
  NODE* node;
  list = new_list();
  
  while(gets(buffer) != NULL){
    node =  (NODE *)(malloc(sizeof(NODE)));
    node->data = malloc(sizeof(double));
    sscanf(buffer, "%lf", node->data);
    add_node(list, node);
  }
   
  
  n = list_length(list);
  if(n %2)
    n-= 1;

  datain = (double *)(malloc(n * sizeof(double)));
  dataout = (double *)(malloc(n * sizeof(double)));

  node = last_node(list);

  for(i = 0; i < n; i++){
    datain[i] = *((double *)(node->data));
    node = prev_node(list);
  }

  realfft(datain, n, dataout);

  for (i=0; i < (n/2); i++){
    totalP += ((dataout[2 * i] * dataout[2 * i])
      + ( dataout[(2 * i) + 1] * dataout[(2 * i) + 1]));
    totalA += pow(((dataout[2 * i] * dataout[2 * i])
      + ( dataout[(2 * i) + 1] * dataout[(2 * i) + 1])), .5);
  }

  for (i=0; i < (n/2); i++){
    psd = (dataout[2 * i] * dataout[2 * i]) 
      + ( dataout[(2 * i) + 1] * dataout[(2 * i) + 1]);
    printf("f = %d\tSin = %f\tCosine = %f\tPSD(f) = %f\tsqrt(PSD) = %.2f\t%%sqrt(PSD) = %.2f\t%%PSD = %.2f\n", 
	   i, dataout[2 * i], 
	   dataout[(2 * i) + 1], psd, pow(psd, .5), 100.0 * pow(psd, .5)/totalA, (100.0 *(psd / totalP)));
	   
  }

  exit(0);
}
  
						      
