.if exists(/usr/bin/uname)
UNAME=/usr/bin/uname
.elif exists(/bin/uname)
UNAME=/bin/uname
.else
UNAME=echo Unknown
.endif

.ifndef OPSYS
OPSYS!=                 ${UNAME} -s
.endif
.ifndef OS_VERSION
OS_VERSION!=            ${UNAME} -r
.endif

.if ${OPSYS} == "NetBSD"
LOWER_OPSYS?=           netbsd
.elif ${OPSYS} == "SunOS"
.if ${MACHINE_ARCH} == "unknown"
LOWER_ARCH!=            ${UNAME} -p
.endif
LOWER_VENDOR?=          sun
LOWER_OPSYS?=           solaris
.elif ${OPSYS} == "Linux"
LOWER_OPSYS?=           linux
.if ${MACHINE_ARCH} == "unknown"
LOWER_ARCH!=            ${UNAME} -m | sed -e 's/[456]86/386/'
.if ${LOWER_ARCH} == "i386"
LOWER_VENDOR?=          pc
.else
LOWER_VENDOR?=          unknown
.endif
.endif

.elif !defined(LOWER_OPSYS)
LOWER_OPSYS!=           echo ${OPSYS} | tr A-Z a-z
.endif

.if ${OPSYS} == "SunOS"
DATE?=	/usr/xpg4/bin/date
.else
DATE?=	date
.endif
# Needed on NetBSD and SunOS (zoularis) to prevent an "install:" target
# from being created in bsd.own.mk.
#NEED_OWN_INSTALL_TARGET=no

BINDIR?=	${PREFIX}/bin
ETCDIR?=	${PREFIX}/etc
INCLUDEDIR?=	${PREFIX}/include
LIBDIR?=	${PREFIX}/lib
LINTLIBDIR?=	${PREFIX}/libdata
LIBEXECDIR?=	${PREFIX}/libexec
MANDIR?=	${PREFIX}/man
SBINDIR?=	${PREFIX}/sbin
SPOOLDIR?=	${PREFIX}/nastore
DBDIR?=		${PREFIX}/libdata/nastore
LIBLINTDIR?=	${PREFIX}/libdata/lint

# Note the following is hard-coded into many make files when looking for
# this file.
SHAREDIR?=	${PREFIX}/share/nastore

STDCPPFLAGS=	-I. -I${.CURDIR} -I${INCLUDEDIR} -DTP_SET_BLK -DTP_SET_CMP

STDLDFLAGS=		-L${LIBDIR} -Wl,-R${LIBDIR}

# Make install targets only install if needed
UPDATE=	1

clobber:	clean
	rm -f ${.CURDIR}/.depend .depend

.SUFFIXES: .1m .7m .cat1m .cat7m

.1m.cat1m .7m.cat7m:
.if !defined(USETBL)
	@echo "${NROFF} -mandoc ${.IMPSRC} > ${.TARGET}"
	@${NROFF} -mandoc ${.IMPSRC} > ${.TARGET} || \
	 (rm -f ${.TARGET}; false)
.else
	@echo "${TBL} ${.IMPSRC} | ${NROFF} -mandoc > ${.TARGET}"
	@${TBL} ${.IMPSRC} | ${NROFF} -mandoc > ${.TARGET} || \
	 (rm -f ${.TARGET}; false)
.endif

