#ifndef NAS_LOGMSG_H
#define NAS_LOGMSG_H

/*
 *  NAStore
 *
 *  nas_logmsg.h: NAStore logging
 *
 * $Header: /Volumes/TempStorage/repos/netbsd/othersrc/nastore/nasutil/nas_logmsg.h,v 1.1.1.1 2000-02-28 02:18:17 wrstuden Exp $
 */

#include <errno.h>		/* for EL_SYS */

/*
 *  Global variables:
 */

extern char	*nErrStr;	/* last err string when EL_CODE used */

/*
 *  Exported routines
 */

extern int	nSysLogCode(char *str);

extern void	nLogInit( const char *caller, int (*onfatal)() );
extern void	nLogInitStderr(int flags);
extern void	nLogInitFile(const char *fname, 
			 int flags, 
			 int renamelog,
			 const char *rname);
extern void	nLogCloseFile(const char *fname); 
extern void	nLogInitConsole(int syslog_fac, int console, int flags);
extern void	nLogSetLevel(int level);

extern int	nLogLevel();
extern void	nClearError();
extern void	nLogMsg(unsigned int, char*, char*, ...);

#define	EL_LEVEL		0x000001ff	/* mask for log level	*/
#define 	EL_ALWAYS	0x00000001
#define		EL_ERROR1	0x00000002
#define		EL_ERROR2	0x00000004
#define		EL_STATUS1	0x00000008
#define		EL_STATUS2	0x00000010
#define		EL_DEBUG1	0x00000020
#define		EL_DEBUG2	0x00000040
#define		EL_DEBUG3	0x00000080
#define		EL_DEBUG4	0x00000100
#define EL_ACTION		0x0007f000	/* mask for special actions */
#define		EL_FATAL	0x00001000	/* call 'fatal' routine */
#define		EL_SYS_		0x00002000	/* print sys err string; 
							see below */
#define		EL_NOTIME	0x00004000	/* don't print time info */
#define		EL_CODE		0x00008000	/* save msg in buffer for 
							later use */
#define		EL_CODEONLY	0x00010000	/* save msg in buffer for later 
							use & don't print */
#define		EL_TOSTDERR	0x00020000	/* log error to stderr	*/
#define		EL_CONSOLE0	0x00040000	/* send msg to RP console */
#define		EL_CONSOLE1	0x00080000	/* send msg to local console */
#define	ERRNOMASK		0xff000000	/* see ERRNOSHFT	*/

#define	ERRNOSHFT	24

#define EL_CONSOLES	(EL_CONSOLE0|EL_CONSOLE1)

/* super macros: */
#define	EL_SYS		(EL_SYS_|((errno << ERRNOSHFT) & ERRNOMASK))


#endif	/* NAS_LOGMSG_H */
