/*
 *  nas_sig.c - signal()-related routines
 */

#include "nasutil.h"
#include <signal.h>

static CodeString_t nSigs[] = {
	{ SIGHUP,	"SIGHUP" },
	{ SIGINT,	"SIGINT" },
	{ SIGQUIT,	"SIGQUIT" },
	{ SIGILL,	"SIGILL" },
	{ SIGTRAP,	"SIGTRAP" },
	{ SIGABRT,	"SIGABRT" },
	{ SIGIOT,	"SIGIOT" },
	{ SIGEMT,	"SIGEMT" },
	{ SIGFPE,	"SIGFPE" },
	{ SIGKILL,	"SIGKILL" },
	{ SIGBUS,	"SIGBUS" },
	{ SIGSEGV,	"SIGSEGV" },
	{ SIGSYS,	"SIGSYS" },
	{ SIGPIPE,	"SIGPIPE" },
	{ SIGALRM,	"SIGALRM" },
	{ SIGTERM,	"SIGTERM" },
	{ SIGURG,	"SIGURG" },
	{ SIGSTOP,	"SIGSTOP" },
	{ SIGTSTP,	"SIGTSTP" },
	{ SIGCONT,	"SIGCONT" },
	{ SIGCHLD,	"SIGCHLD" },
	{ SIGTTIN,	"SIGTTIN" },
	{ SIGTTOU,	"SIGTTOU" },
	{ SIGIO,	"SIGIO" },
	{ SIGXCPU,	"SIGXCPU" },
	{ SIGXFSZ,	"SIGXFSZ" },
	{ SIGVTALRM,	"SIGVTALRM" },
	{ SIGPROF,	"SIGPROF" },
	{ SIGWINCH,	"SIGWINCH" },
#ifdef SIGINFO
	{ SIGINFO,	"SIGINFO" },
#endif
	{ SIGUSR1,	"SIGUSR1" },
	{ SIGUSR2,	"SIGUSR2" },
	{ 0,		NULL }
};

char *
nSigName(int sig)
{
	return(nCodeToStr(sig, nSigs));
}

int
sig_ign(int sig)
{
	if (SIGNAL(sig, SIG_IGN)) {
		nLogMsg(EL_ERROR1|EL_SYS, 0, "sig_ign(%s)", nSigName(sig));
                return(1);
        }
	return(0);
}
