#ifndef NAS_TAPE_H
#define NAS_TAPE_H

/*
 *  nas_tape.h - machine-specific tape driver stuff
 */

#include <sys/mtio.h>
#include <errno.h>

/* 3480 blkid size              */
#define TBLKID int32_t

#define TAPLED_REMOVE           0x20 /* if loaded, display 1st msg till 
					tape rmvd/unlded */
#define TAPLED_LOAD             0x40 /* if unloaded, display 1st msg till
					tape loaded (lights attn light) */
#define TAPLED_COMBO            0xE0 /* if loaded display 1st msg till tape 
					rmvd; once unloaded display 2nd 
					until next loaded */

#define TAPLED_ALTERNATE        0x10 /* alternate msg1, msg2 */
#define TAPLED_BLINK            0x08 /* blink.. */
#define TAPLED_FIRST            0x00 /* set this if msg1 is to be displayed */
#define TAPLED_SECOND           0x04 /* set this if msg2 is to be displayed */
#define TAPLED_AUTOLOAD		0x01 /* load request to auto loader */



#ifndef _CONVEX_SOURCE
/*
 *  Function code value: see drive documentation.
 */
struct mtdisplay {
	unsigned char   function_code;
	unsigned char   message1[8];
	unsigned char   message2[8];
};
#endif



#define ioctlopen(name) open(name, O_FORCEOPEN|O_NDELAY)

extern int	ntp_open(char *path, int write, int blocksize, int compress, 
			int logflg);
extern int	ntp_getstatus(int fd, char *vsn, int logflg);
extern int	ntp_ismounted(char *vsn);
extern int	ntp_write_protected(char *vsn);
extern int	ntp_ateot(char *vsn);
extern int	ntp_locblk(int fd, TBLKID blockid, char *vsn, int logflg);
extern int	ntp_getblk(int fd, TBLKID *blockid, char *vsn, int logflg);
extern int	ntp_taprew(int fd, char *vsn, int logflg);
extern int	ntp_tapfsb(int fd, int count, char *vsn, int logflg);
extern int	ntp_tapbsb(int fd, int count, char *vsn, int logflg);
extern int	ntp_tapfsf(int fd, int count, char *vsn, int logflg);
extern int	ntp_tapbsf(int fd, int count, char *vsn, int logflg);
extern int	ntp_tapwtm(int fd, char *vsn, int logflg);
extern int	ntp_rewunload(int fd, char *vsn, int logflg);
extern int	ntp_tapdse(int fd, char *vsn, int logflg);
extern int	ntp_tapdse2(int fd, int enough, char *vsn, int logflg);

#ifdef _CONVEX_SOURCE
int	ntp_tapled(int, struct mtdisplay *);
#endif
int	LED34X0(int, char, char *, char *);

int	tapled(int, struct mtdisplay *);

#endif	/* NAS_TAPE_H */
