#include "nasutil.h"
#include <signal.h>

getkid(int sig)
{
	int	pid, stat;

	printf("got SIGCHLD\n");
	pid = waitproc(&stat);
	printf("pid %d  stat %d\n", pid, stat);
	exit(0);
}

int
waitproc(int *stat)
{
	register int	sig;
	int		status, pid;

	if ((pid=wait(&status))==-1) {
		perror("wait");
		exit(1);
	}
	status &= 0177777;
	sig = status & 0177;
	status >>= 8;
	if (sig) {			/* signal */
		printf("child %d terminated on signal %d\n", pid, sig);
	}
	*stat = status;
	return(pid);
}

main()
{
	int	whoami;

	if (SIGNAL(SIGCHLD, getkid)) {
		perror("signal");
		exit(1);
	}
	if ((whoami=fork()) == -1) {
		perror("fork");
		exit(1);
	}
	if (whoami)
		sleep(120);
	else 
		exit(4);
}
