#include	<stdio.h>
#include	<ctype.h>

#include	<sys/types.h>
#include	<sys/param.h>


/*
**	Process a line from (arc/free)build and restore the mangled
**	name to the original.
*/
int
file_line(FILE *fin, uid_t *uid, gid_t *gid, off_t *filesize, char *filename)
{
	char		line[PATH_MAX+256];
	char		*ch, *s, *p;
	long long	fsize;
	int		c;

	ch = line;
	while ((c = getc(fin)) != EOF && c != '\n') 
		*ch++ = (char)c;

	if (c == EOF)
		return 1;

	*ch = '\0';
	if (sscanf(line, "%8d %8d %15lld", uid, gid, &fsize) != 3)
		return -1;

	*filesize = (off_t)fsize;

	for (ch=line; isspace(*ch) && *ch; ch++);	/* blanks */
	for (; !isspace(*ch) && *ch; ch++);		/* uid */
	for (; isspace(*ch) && *ch; ch++);		/* blanks */
	for (; !isspace(*ch) && *ch; ch++);		/* gid */
	for (; isspace(*ch) && *ch; ch++);		/* blanks */
	for (; !isspace(*ch) && *ch; ch++);		/* filesize */
	for (; isspace(*ch) && *ch; ch++);		/* blanks */

	for (s = ch, p = filename; *s; s++) {
		if (*s == '\\') {
			sscanf(s + 1, "%3o", &c);
			s += 3;
			*p++ = (char)c;
		} else {
			*p++ = *s;
		}
	}
	*p = '\0';

	return 0;
}
