#ifndef _BFID_H
#define _BFID_H

#ifndef DEFAULT_BFID_HOME
#define DEFAULT_BFID_HOME "/usr/mss/etc/bfidsrv"
#endif


/* 
   a bfid is an array of 16 chars. The parts of the bfid are not of importance
   to the client requesting the bfid, save that the client should know the
   site_id and could use that for a consistency check.

 0-3 reserved (int4) (nulls) 
 4-7 site id  (int32_t in network byte order)
 8-9 generator id (int16_t in network byte order) 
 10-15 sequence (int16_t[3] 3 int16's, each in network byte order )

*/

/* 
   each file contains the string representation of an appropriately sized 
   integer. the sequence file contains an 48 bit hex number in the form
   
   0x0000NNNNNNNNN where the N's are the hex digits

   As such, you can move them between different architectures as you 
   see fit 
*/

#define SITE_ID_FILE "db/site"
#define GENERATOR_ID_FILE "db/generator"
#define SEQUENCE_FILE "db/sequence"
#define MAX_BFID_REQUEST 4096
#define MIN_BFID_REQUEST 1

int	cache_bfid(int increment);
int	bfid_init(void);
int	getbfid(bfid_t *bP);
#endif
