#ifndef __LABELS_H
#define __LABELS_H

#define ENDMRK_LEN	5			/* don't include nil */

/* 
 * character definition of labels on a tape
 */
typedef struct  {
	char	hdr[4],			b0;	/* 'RASH'		*/
	char	vvname[MAXVVNAMELEN],	b1;	/* this vv		*/
	char	version[INTLEN],	b2;	/* rash version		*/
	char	dbuid_name[10],		b3;	/* owner when bfid assigned */
	char	dbuid[INTLEN],		b4;	/* dbuid number		*/
	char	date[DATELEN],		end;	/* time label written	*/
} vv_hdr_lbl_t;

typedef struct  {
    /* basic info */
	char	hdr[4],			b00;	/* 'FILE'		    */
	char	label[3],		b01;	/* 'HDR' 'EOV' or 'EOF'	    */
	char	version[INTLEN],	b02;	/* rash version		    */
    /* file-vv mapping */
      /* multi-vv files */
	char	vv0[VVNAMELEN],		b03;	/* 1st vv for file	    */
	char	vvno[5],		b04;	/* volume order number	    */
	char	othervv[VVNAMELEN],	b05;	/* prev or next vv for file */
      /* multi-file vv */
	char	fno[5],			b06;	/* which file on this vv    */
    /* file info */
	char	bfid[BFIDLEN],		b07;	/* bfid in ascii hex	    */
	char	uname[10],  		b08;	/* username		    */
	char	uid[INTLEN],		b09;	/* file uid in ascii hex    */
	char	gname[10],		b10;	/* group name		    */
	char	gid[INTLEN], 		b11; 	/* file gid in ascii hex    */
	char	mode[4],		b12;	/* file mode in ascii hex   */
	char	mtime[DATELEN],		b13;	/* mtime		    */
	char	ctime[DATELEN],		b14;	/* ctime 		    */
	char	arctm[DATELEN],		b15;	/* archive time 	    */
	char	fsize[OFFLEN],		b16;	/* file size in ascii hex   */
        char    lseek[OFFLEN],		b17;	/* lseek address hex	    */
	char	vvdata[OFFLEN],		b18;	/* amt of file on this vv   */
        char    flen[4],		end;	/* length of file name hex  */
} file_hdr_lbl_t;
 

/* 
 * Prototypes
 */
int		lbl_vv_hdr(vv_handle_t *vhp, char *vvname, 
				char *dbname, uid_t dbuid);
int		lbl_vv_hdrcheck(vv_handle_t *vhp, char *vvname,
				char *dbname, uid_t dbuid);

file_hdr_lbl_t	*lbl_file_hdr(vv_handle_t *vhp, USR_FILEINFO *fP, 
				char *groupname, 
				char *vv0name, char *prevvname);

int		lbl_eof(vv_handle_t *vhp, file_hdr_lbl_t *lP);
int		lbl_eof_check(vv_handle_t *vhp, USR_FILEINFO *uP);
int		lbl_eov(vv_handle_t *vhp, file_hdr_lbl_t *lP, 
				char *nextvvname);

int		lbl_skipbof(vv_handle_t *vhp, vvlist_t *vlP, USR_FILEINFO *fp);

#endif
