#ifndef _RASHCOM_H
#define _RASHCOM_H

/*
 *  rashcom.h
 */

/*
** The following is a description of the RASH configurable definitions
** Note: The location of the rash data base is defined in dblib.h 
** 
** MAXRESTORES  maximun number of restores that can be active at one time
** RASH_RID     Volume Manager id name
** RASH_VVID	string combined with uid to form VV id.
*/
#define MAXRESTORES     10
#define RASH_RID      	"rash"
#define	RASH_VVID	"R"

#define	ERRORARC	SPOOLDIR "/rash/ARCHIVE_LOG"
#define	ERRORRES	SPOOLDIR "/rash/RESTORE_LOG"

#define EL_ERROR	(EL_ERROR1 | EL_TOSTDERR )

#define	NAMELEN		20
#define	MAX_RESI	1024*1024*1024		/* 1Gb */

typedef struct {
	char		vvname[MAXVVNAMELEN+1];
	off_t		vvlseek;
	off_t		flseek;
	off_t		vvdata;
	int		fno;
	int		lastfno;
	int		new;
} vvlist_t;

extern	off_t	leave_resi;
extern	uid_t	userid;
extern	int	aflg;
extern	int	resetflg;
extern	int	recurse;
extern	int	rash_fd;

int		fatal(void);
void		intrpt(int signum);
int		rashvv(char *filename, struct stat *sP);

int		resetfd(char *id, char *fname);
vvlist_t	*getdb(USR_FILEINFO *uhold,
			struct stat *sP, rashstat_t *rP, int *nvv);
int		restfile(USR_FILEINFO *fP,
			struct stat *sP, rashstat_t *rP,
			vvlist_t *vvlist, int nvv);

void		vvErrorMsg(uint logflags, char *id, char *str);
#endif /* RASHCOM_H */
