#include	<stdio.h>
#include	<stdlib.h>
#include	<unistd.h>
#include	<string.h>
#include	<fcntl.h>
#include	<dirent.h>

#include	<sys/types.h>
#include	<sys/param.h>
#include	<sys/stat.h>

#include	"dmfsd.h"

typedef	struct	DirList {
	char		*name;
	struct	DirList	*next;
} DirList_t;

/*
**	Function to decend file tree.
*/
int
traverse(char *path, int (*action)(char *, struct stat *))
{
	struct	stat	sbuf;
	char		filepath[PATH_MAX+1];
	size_t		filelen;
	struct	dirent	*dp;
	DIR		*dirp;
	DirList_t	*listp;
	DirList_t	*lp;
	int		rc;

	if (lstat(path, &sbuf) == -1) {
		perror(path);
		return 1;
	}

	if (S_ISREG(sbuf.st_mode))
		return (action(path, &sbuf));
	else if (!S_ISDIR(sbuf.st_mode))
		return 0;		/* not interesting */


	/*
	**	If the file is a directory, we need to open it and
	**	create a list of entries, then decend the tree.
	*/
	if ((dirp = opendir(path)) == NULL) {
		perror(path);
		return 1;
	}

	strcpy(filepath, path);
	filelen = strlen(filepath);
	filepath[filelen++] = '/';
	listp = NULL;

	/*
	**	Now, recursively call traverse() to
	**	handle each entry in this directory.
	*/
	while ((dp = readdir(dirp)) != NULL) {
		if (dp->d_name[0] == '.') {
			if ( dp->d_name[1] == '\0' ||
			    (dp->d_name[1] == '.' && dp->d_name[2] == '\0'))
				continue;
		}

		strcpy(&filepath[filelen], dp->d_name);
		lp = malloc(sizeof(*lp));
		lp->name = strdup(filepath);
		lp->next = listp;
		listp = lp;
	}
	closedir(dirp);

	rc = 0;
	for (lp = listp; lp; lp = listp) {
		if (traverse(lp->name, action))
			rc = 1;
		free(lp->name);
		listp = lp->next;
		free(lp);
	}
	return rc;
}
