/*
 *  vv.c - NAStore RASH general lib for VVM interface
 *
 *	Bill Ross, NASA Ames, July, 1998
 */
#include	"vv_cl.h"

void
vvErrorMsg(uint logflags, char *id, char *str)
{
	int	saverr;
	char	errstr[MAXVVERRLEN];

	/*
	 *  save current VV error info
	 */
	strncpy(errstr, vv_errstr, (size_t)MAXVVERRLEN-1);
	saverr = VVError;

	/*
	 *  log msg
	 */
	if (str != NULL) {
		nLogMsg(logflags, id, "VVM: (%s) %s /%s", 
			str, errstr, vvErrStr(saverr));
	}
	else {
		nLogMsg(logflags, id, "VVM: %s /%s", 
			errstr, vvErrStr(saverr));
	}

	/*
	 *  reset err code for handling
	 */
	VVError = saverr;
}
