#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

#include <sys/file.h>

/*
**	Program "plug" to clog a pipe.  Use a
**	file in the current directory and flock to get an
**	exclusive lock.  Then call system to run the program(s)
**	reading the pipe.
*/
int
main(int argc, char *argv[])
{
	char	*lockfile = ".hairball";
	int	fd, ch, err;
	int	ret = 0;
	char	buf[1024], *cp;
	extern	char	*optarg;
	extern	int	optind;

	err = 0;
	while ((ch = getopt(argc, argv, "f:")) != -1) {
		switch (ch) {

		case 'f':
			lockfile = optarg;
			break;

		case '?':
		default:
			err++;
			break;
		}
	}
	if (optind == argc)
		err++;

	if (err) {
		fprintf(stderr, "usage: %s [-f lockfile] arg(s)\n", argv[0]);
		exit(1);
	}

	/*
	**	Don't run the pipe if the lock is not available.
	*/
	if ((fd = open(lockfile, O_RDONLY|O_CREAT, 0600)) == -1) {
		perror(lockfile);
		exit(1);
	}
	if (flock(fd, LOCK_EX|LOCK_NB) == -1) {
		perror("flock");
		close(fd);
		exit(1);
	}

	for (cp=buf; optind < argc; optind++) {
		strcpy(cp, argv[optind]);
		cp += strlen(argv[optind]);
		*cp++ = ' ';
	}
	cp--;
	*cp = '\0';

	if (system(buf) == -1) {
		perror("system");
		ret = 1;
	}

	close(fd);	/* release lock */
	return ret;
}
