#ifndef lint
static char rcsid[] = "$Header: /Volumes/TempStorage/repos/netbsd/othersrc/nastore/volman/clnt/volalloc.c,v 1.1.1.1 2000-02-28 02:18:24 wrstuden Exp $";
#endif

#include "cl_space.h"
#include <stdio.h>

static char	*arg0;

 void
usage()
{
	fprintf(stderr, 
		"usage: %s RC [-t type] [-g group] [-n number]\n", arg0);
	fprintf(stderr, 
		"\ttype: must be specified if RC configured for > 1 medium\n");
	vm_prRCTypes(stderr);
	exit(1);
}

main(int argc, char *argv[])
{
	extern  int     optind;
	extern  char    *optarg;
	int		cc, i, retval = 0;
	vsn_t		*vsnp;				/* from vm.h */
	RC_t		*rcp;
	int		voltype = -1;
	int		nalloc = 1, poolgid = 0, vsngid = getgid();

	arg0 = argv[0];

	if (vm_init(argv[0])) {
		vm_prerr(stderr);
		exit(VMError);
	}
	if (vm_configRC()) {
		vm_prerr(stderr);
		exit(VMError);
	}
	if (argc < 2  ||  argc > 8)
		usage();

	if ((rcp = cGetRcp(argv[1])) == NULL) {
		fprintf(stderr, "%s: bad RC\n", argv[1]);
		usage();
	}

	argc--;
	argv++;

	while ((cc = getopt(argc, argv, "g:t:n:")) != EOF) {
		switch (cc) {

		    case 't': {
			/*
			 *  type
			 */
			VolType_t	*vtp;

			if ((vtp = vVolTypeByID(optarg)) == NULL) {
				fprintf(stderr, "unknown type %s\n", optarg);
				usage();
			}
			if (!(vtp->vt_medium & rcp->rcd_media)) {
				fprintf(stderr, "type %s not in RC %s\n", 
						optarg, rcp->rcd_id);
				usage();
			}
			voltype = vtp->vt_map;
			break;
		    }
		    case 'g':
			if (vm_groupid(optarg, &poolgid))
				usage();
			break;
		    case 'n':
			if (!isnum(optarg))
				usage();
			nalloc = atoi(optarg);
			if (nalloc < 1) {
				fprintf(stderr, "%s: bad number to allocate\n",
					optarg);
				usage();
			}
			break;
		    default:
			usage();
		}
	}
	if (voltype == -1  &&  rcp->rcd_nmedia > 1) {
		fprintf(stderr, "Need volume type\n");
		usage();
	}

	printf("allocating volume%s from %s\n", (nalloc > 1 ? "s":""),
						rcp->rcd_name);
	for (i=0; i<nalloc; i++) {
		/*	 	rc_num poolgid voltype 
							description  mode  GID*/
		vsnp = vm_alloc(rcp->rcd_number, poolgid, voltype, 
							NULL, 0644, vsngid);
		if (vsnp)
			printf("allocated vsn: %.*s\n", VSNLEN, vsnp);
		else {
			vm_prerr(stderr);
			retval = 1;
			break;
		}
	}

	vm_term();
	return retval;
}
