/*
 * vrecycle command -- user interface to release ownership on volumes in the
 *	volman(8) database.
 *
 *
 *	Bill Ross, NASA Ames, 2/26/92
 */

#include <ctype.h> 
#include <stdio.h>
#include <time.h>

#include "cl_space.h"

extern int errno;

int	uid;

/*
 * Print out usage message and exit.
 */
 void
usage(char *arg0)
{
	fprintf(stderr,
	  "usage: %s [-e] volsers \n", arg0);
	fprintf(stderr,"\t-e\tRecycling because of error\n");
	exit(1);
}

main(int argc, char *argv[])
{
	char		*arg0 = argv[0];
	int		i, rval = 0, uerr = 0, uid = getuid();
	int		argstart = 1;

	/*
	 *  check args
	 */
	if (argc == 1)
		usage(arg0);
	if (!strcmp(argv[1], "-e")) {
		uerr = 1;
		if (argc == 2)
			usage(arg0);
		argstart++;
	}

	/*
	 *  connect w/ voldaemon and build basic packet to send
	 */
	
	if (vm_init(arg0)) {
		vm_prerr(stderr);
		exit(VMError);
	}

	/*
	 *  do each vsn
	 */

	for (i=argstart; i<argc; i++) {
		int	ret;

		if (checkvsn(argv[i])) {
			printf("\n%s\n", nErrStr);
			continue;
		}
		
		printf("sending %.*s\n", VSNLEN, argv[i]);
		if (vm_recycle(argv[i], uerr)) {
			vm_prerr(stderr);
			if (VMError != E_PERM  &&  VMError != E_USER)
				exit(VMError);
			if (VMError == E_PERM)
				fprintf(stderr, 
					"\t(Root must use volmoddb -u)\n");
			rval++;
		} else
			printf("recycled %s\n", argv[i]);
	}
	vm_term();
	exit(rval);
}

