/*
 *  Volume Manager
 *
 *  cl_space.h: space and type declarations for clients;
 *	space is allcated in cl_lib.c
 *
 * $Header: /Volumes/TempStorage/repos/netbsd/othersrc/nastore/volman/lib/cl_space.h,v 1.1.1.1 2000-02-28 02:18:22 wrstuden Exp $
 */
#ifndef	_CL_SPACE_H
#define _CL_SPACE_H

#include "vm_space.h"

extern int		lPid, lUid;


/*
 * CVolReq_t: structure used by the client to manage and track the
 *	volume requests sent out by an AC
 */
typedef struct ClientVolumeRequest {
	vsn_t		cvr_vsn;	/* for lookups */
	Seq_t		cvr_seq;	/* sequence no. of last request */
	vmpHdr_t	*cvr_lastpkt;	/* header & msg of last received pkt */
	int		cvr_newpkt;	/* 1 if crv_lastpkt not read yet */
	QLink_t		cvr_q;		/* links in queue */
} CVolReq_t;

#define EnQCVR(cvreqp, headp)	ENQUEUE(cvreqp, headp, cvr_q, CVolReq_t)
#define	DeQCVR(cvreqp, headp)	DEQUEUE(cvreqp, headp, cvr_q, CVolReq_t)

/* from cl_sock.c */
extern int		ClientInitIPC(int flag, unsigned int logflags);
extern void		ClientTermIPC(int saverror);
extern int		lSnd2RP(vmpHdr_t *hp);
extern vmpHdr_t		*lRcvFromRP(int delay);

/* from cl_lib.c: */
extern int		vm_init(char *id);
extern int		vm_initp(char *id);
extern int		_vm_init(char *id, int flag);
extern int		vm_term();

extern void		vm_prerr(FILE *fp);

extern int		vm_signal(int sig);
extern int		vm_mount(vsn_t *vsnp, int flags, char *rid, 
				char *tag, int waitnow, int delmsg);
extern int		vm_mount_pll(unsigned int nvsns, char **vsns, int flags,
				char *tag);
extern int		vm_mount_sel(unsigned int nvsns, char **vsns, int flags,
				char *tag);
extern int		vm_unmount(vsn_t *vsnp, int flags, int waitnow, 
				int delmsg);

extern int		vm_move(vsn_t *vsnp, int rcno);

extern int		vm_attach(vsn_t *vsnp, int flags, int delmsg);
extern int		vm_detach();

extern void		vPrintStatTab(FILE *fptr);
extern vmpVolStat_t	*vm_getstat(vsn_t *vsnp, Seq_t seq, int delay, 
				int ack, int *countp, int delmsg);
extern int		vm_prvolstat(vsn_t *vsnp, FILE *fp);
extern int		vm_prvolstatarr(REG vmpVolStat_t *vsp, int count, 
				FILE *fp, int sort, int ppid, int tag, 
				int ptime, int dest);

extern vsn_t		*vm_alloc(int rcno, int poolgid, int voltype, 
				char *desc, int mode, int gid);
extern int		vm_recycle(char *vsn, int uerr);

extern VDR_t		*vm_vinfo(char *vsn);

extern void		lProcPkts(int delay);
extern CVolReq_t	*lGetCVRbyVSN(REG vsn_t *vsnp);
extern CVolReq_t	*lGetCVRbySeq(REG Seq_t seq);
extern void		lPurgeCVReqs();

extern int		checkvsnrange(vsn_t *vsnp, int range);

extern int		vm_writelabel(int fd, char *internal, char *vsn, 
				char *cmdname);
extern int		vm_readlabel(int fd, char *vsnp, char *cmdname);

extern void		vm_initlist(char *id, int prolog);
extern int		vm_getvsnfromfile(FILE *fp, char *vsnp);
extern char		*vm_getvsnfilelist(FILE *fp, int *countp);
extern char		*vm_getvsnarglist(char **argv, int argc, 
				int *countp, int *errp);

extern int		vm_userid(char *str, int *uid);
extern int		vm_groupid(char *str, int *gid);
extern int		vm_octalperm(char *str, short *perm);

/* from cl_host.c */

extern HostInfo_t	*HostInfo(int i);

/* from cl_{ipc}.c */

extern vmpHdr_t		*lRcvFromRP(int delay);

/* from cl_device.c */

extern int		vm_vary(DevMap_t *dmp, int flags, char *errstr);

#endif /* _CL_SPACE_H */
