#ifndef _VM_H
#define _VM_H

/*
 * Volume Manager
 *
 * vm.h: Volume Manager misc.
 *
 * $Header: /Volumes/TempStorage/repos/netbsd/othersrc/nastore/volman/lib/vm.h,v 1.1.1.1 2000-02-28 02:18:22 wrstuden Exp $
 */

/* #define NEWRC */

/*
 *  Configurable constants
 *	Note: LIBDIR, SPOOLDIR and others are set in Makefile
 */

#define	ERRORLOG	"ErrorLog"	/* Error Log file (in SPOOLDIR)	*/

#define CLIENTDIR	"tmp"		/* SPOOLDIR subdir for client comms */

/*
 * End of configurable constants
 */

/*
 * Fundamental constants: DO NOT CHANGE THESE
 */
#define	VM_VERSION	30		/* version number		*/
#define	IORETRY		9		/* times to retry failed IOs	*/
#define	TIMER		"voltimer"	/* timer daemon in LIBDIR 	*/
#define	TIMERSECS	"30"		/* seconds between timer ticks */
#define	VOLNODE		"volnode"	/* lbl check / node setup daemon*/
#ifdef DEBUG
#define	RPUID		getuid()	/* UID RP runs under (any acct)	*/
#else	/* DEBUG */
#define	RPUID		0		/* UID RP runs under (root)	*/
#endif	/* DEBUG */
#define	VOLMANUID	VolManOperUID	/* UID of VOLMANACCT (computed)	*/

#ifdef DEBUG
#define	REG				/* no registers for now		*/
#else
#define	REG		register
#endif
#define	MATCH		0		/* for memcmp(), strcmp()	*/


#define	SAMEVSN(vsn1p, vsn2p)	\
	((strncmp((vsn1p)->v_vsn, (vsn2p)->v_vsn, sizeof(vsn_t))) ? 0 : 1)

/* for vPvrlShutdown() */
#define	SAVERROR	1		/* don't overwrite VMError	*/
#define	NEWERROR	0		/* overwrite VMError		*/

/* for vBuildHdr() */
#define	NOSEQ		((Seq_t)-1)		/* no sequence number		*/

extern int	errno;

#endif /* _VM_H */
