/*
 *  Volume Manager
 *
 *  vm_device.h: device-related stuff that doesn't make it thru
 *	rpcgen so isn't bundled in vm_pkt.x. 
 *
 *	RP keeps the master device config, and clients
 *	(including RCs) get it from there.
 *
 *  Note: if full distributed volume mgt is implemented, the device
 *	host and path prefix (/dev, /dev/rmt, etc) can be found
 *	from the RC indicated in the device structure.
 *
 *
 *  Bill Ross, NASA Ames, June 1995. 
 *  Original bitmapping & structs by Jon Hahn.
 */

#ifndef	_DEVICE_
#define	_DEVICE_


#define	DM_SET(n, p)	((p).dms_bits[(n)/NDMBITS] |= (1 << ((n) % NDMBITS)))
#define	DM_CLR(n, p)	((p).dms_bits[(n)/NDMBITS] &= ~(1 << ((n) % NDMBITS)))
#define	DM_ISSET(n, p)	((p).dms_bits[(n)/NDMBITS] & (1 << ((n) % NDMBITS)))
#define DM_ZERO(p)	(void) memset((char *)&(p), '\0', sizeof(p))
#define DM_AND(p, q, r) { \
			int _i_; \
			for (_i_=0; _i_<howmany(DM_SETSIZE,NDMBITS); _i_++) \
				(r).dms_bits[_i_] = \
					(p).dms_bits[_i_] & (q).dms_bits[_i_]; \
			}

#endif	/* _DEVICE_ */
