/*
 *  vm_host.c - for drive naming conventions
 */

#include "vm_space.h"

CodeString_t vHostTypes[] = {
	{ VH_CONVEX,	"CONVEX" },
	{ VH_SGI,	"SGI" },
	{ VH_SUN,	"SUN" },
	{ VH_SUN,	"SunOS" },
	{ VH_LINUX,	"LINUX" },
	{ VH_NETBSD,	"DECALPHA" },
	{ VH_NETBSD,	"INTEL" },
	{ VH_NETBSD,	"NetBSD" },
	{ 0,		NULL }
};

  char *
vHostStr(int type)
{
	return(nCodeToStr(type, vHostTypes));
}

  int
vHostCode(char *str)
{
	return(nStrToCode(str, vHostTypes));
}

  void
vPrintHostTypes(int loglev, char *id)
{
	CodeString_t	*tp = vHostTypes;

	for (tp=vHostTypes; tp->cs_string; tp++)
		nLogMsg(loglev, id, "\t%s", tp->cs_string);
}

  int
vHostTypeConfig(int type)
{
	CodeString_t	*tp = vHostTypes;

	for (tp=vHostTypes; tp->cs_string; tp++)
		if (tp->cs_code == type)
			return(1);
	return(0);
}
