/*
 * Terminology:
 *	a "header" is a vmpHdr_t
 *	a "message" is an associated data structure
 *	a "packet" is a contiguous header and (optional) message
 *
 *	MSGPTR() returns a pointer to the message of a packet given
 *		a header pointer and the message struct type
 *	PKTSIZ() returns the size of the packet given the message
 *		struct type - plus 16 bytes to allow for hdr & struct
 *		padding, if needed
 *	PKTSIZ2() does the same as PKTSIZ() but returns the size of
 *		the larger packet (I'm surprised this works!)
 */

#define	emsgcpy(dst,src) \
	if (src) {					\
		strncpy((dst),(src),(size_t)LINELEN); \
		dst[LINELEN-1] = '\0'; \
	} else dst[0] = '\0';

#define	MSGPTR(hdrptr, struct)	((struct *)((char *)(hdrptr) + \
					PadSize(sizeof(vmpHdr_t))))
#ifndef MAX
#define MAX(a,b)		((a) > (b) ? (a) : (b))
#endif
#define	PKTSIZ(struct)		(sizeof (vmpHdr_t) + sizeof (struct) + 16)
#define	PKTSIZ2(s1, s2)		(sizeof (vmpHdr_t) + 16 + \
				  MAX(sizeof (s1), sizeof (s2)))

#define	vAllocPkt(msgptr)	(vmpHdr_t *) \
				(nAlloc(sizeof (vmpHdr_t) + (msgptr)->vh_size))
