#ifndef _VM_VOLTYPE_H
#define _VM_VOLTYPE_H
/* 
 *  vm_voltype.h
 */

/*
 *  vt_map values as used in volman dbase - do not change w/out
 *	updating dbase & vm_voltype.c table; also see vm_systape.c
 */
#define	VT_RND_400	1
#define VT_34X0_600	2
#define VT_34X0_800	4
#define VT_D2		5
#define VT_D3		6
#define VT_EXA		7
#define VT_DAT		8
#define VT_CREO		9
#define VT_MAGSTAR	10
#define VT_AIT		11
#define VT_DLT		12

/* 
 *  vt_medium values - bits for use in RC defs because RCs can handle > 1
 */
#define VM_RND		0x01
#define VM_34X0		0x02
#define VM_D2		0x04
#define VM_D3		0x08
#define VM_MAGSTAR	0x10
#define VM_AIT		0x20
#define VM_DLT		0x40

typedef struct VolType {
	int		vt_map;		/* numerical id */
	int		vt_medium;
	int		vt_bufsize;	/* suggested i/o bufsize	      */
	int		vt_capacity1;	/* guaranteed Mbytes (no compression) */
	int		vt_capacity2;	/* estimated max Mbytes (compression) */
	int		vt_flags;
	int		vt_weartime;	/* max time to leave mounted/idle     */
	char		*vt_id;		/* short name */
	char		*vt_name;	/* description */
} VolType_t;


#endif /*_VM_VOLTYPE_H */
