#ifndef lint
static char rcsid[] = "$Header: /Volumes/TempStorage/repos/netbsd/othersrc/nastore/volman/srvr/admin/vnewlog.c,v 1.1.1.1 2000-02-28 02:18:27 wrstuden Exp $";
#endif
/*
 *  Volume Manager
 *
 *  vnewlog.c - start new volman log(s)
 *	
 *
 *  Bill Ross, Computer Sciences Corporation for NAS/NASA Ames, 8/22/89
 */

#define EXTERN
#include "srv_space.h"
#include <ctype.h>

main(argc, argv)
  char	*argv[];
{
	int		operr, err, uid, flag;
	vmpHdr_t	hdr, *rhp;
	vmpError_t	*ep;

	CheckUID(argv[0]);

	/*
	 *  check arguments
	 */

	if (argc != 1) {
		fprintf(stderr, "usage: %s\n", argv[0]);
		exit(1);
	}

	/*
	 *  set up connection with RP & send msg
	 */
    	nLogInit(argv[0], NULL);
	flag = 0;
	RPCLInit(M_CONSOLE, &flag);

	vBuildHdr(M_NEWLOG, vGetSeq(), &hdr);
	RPCLSend(&hdr, 1);

        /*
         *  get response
         */
        while (1) {
                rhp = RPCLRecv("getting response");
                if (rhp->vh_seq != hdr.vh_seq) {
                        printf("Unexpected seq #: %s\n", vHdrStr(rhp));
                        continue;
                }
                switch (rhp->vh_type) {
		    case M_ACK:
			goto ok;

		    case M_VERROR:
			ep = MSGPTR(rhp, vmpError_t);
				fprintf(stderr, "error from vold: %s\n",
							ep->vn_msg);
			exit(1);

		    case M_SHUTDOWN:
			fprintf(stderr, "shutdown received\n");
			exit(1);

		    case M_NOP:
			nFree(rhp);
			continue;

		    default:
			printf("Unexpected packet: %s\n", vHdrStr(rhp));
			exit(1);
                }
        }
ok:
	RPCLGoodbye();
	exit(0);
}
