/*
 *  Volume Manager
 *
 *  vprio.c - admin toggle of priority
 *	
 *
 *  Bill Ross, MRJ for NAS/NASA Ames, 1/22/99
 */


#include <pwd.h>
#include <ctype.h>

#ifdef EXTERN
# undef EXTERN
#endif
#define EXTERN
#include "srv_space.h"

static char	*arg0;

usage(str)
{
	fprintf(stderr, "usage: %s toggle\n", arg0);
	fprintf(stderr, "       %s reqid\n", arg0);
	RPCLGoodbye();
	exit(1);
}



main(int argc, char *argv[])
{
	int		err, code;
	vmpHdr_t        hdr;

	arg0 = argv[0];
	CheckUID(arg0);

	/*
	 *  set up connection with vold
	 */
	RPCLInit(M_CONSOLE);

	/*
	 *  check arguments
	 */

	if (argc != 2)
		usage("wrong # of arguments");

	if (!strcmp(argv[1], "toggle"))
		code = 0;
	else {
		if (!isnum(argv[1]))
			usage("bad arg");
		code = atoi(argv[1]);
	}
	vBuildHdr(M_PRIORITY, NOSEQ, &hdr);
	hdr.vh_count = code;
	RPCLSend(&hdr, 1);
	err = GetResponse();
	RPCLGoodbye();
	exit(err);
}



GetResponse()
{
	vmpHdr_t	*rhp;
	vmpError_t	*ep;

	for (;;) {
		/*
		 *  since no select on rcv, can ignore RPCLNextRecord
		 *	return value
		 */
		rhp = RPCLRecv("getting response");
		RPCLNextRecord();

		switch (rhp->vh_type) {
		    case M_ACK:
			return(0);
		    case M_VERROR: 
			ep = MSGPTR(rhp, vmpError_t);
			printf("error from vold: %s\n",ep->vn_msg);
			return(1);
		    case M_SHUTDOWN:
			printf("shutdown received\n");
			vm_term();
			exit(1);
		    case M_NOP:
			nFree(rhp);
			continue;
		    default:
			printf("Unexpected packet type: %s\n", 
							vHdrStr(rhp));
			exit(1);
		}
	}
}
