#ifndef lint
static char rcsid[] = "$Header: /Volumes/TempStorage/repos/netbsd/othersrc/nastore/volman/srvr/admin/vshutdown.c,v 1.1.1.1 2000-02-28 02:18:27 wrstuden Exp $";
#endif

/*
 *  vshutdown command -- shut down vold(1M)
 *	Makes server-type XDR connection.
 *
 *	Bill Ross, NASA Ames, 3/92
 */

#include <stdio.h>

#ifdef EXTERN
# undef EXTERN
#endif
#define EXTERN
#include "srv_space.h"

static	char	*arg0;

usage()
{
	fprintf(stderr, "usage: %s [-r] [-i] [-m msg]\n", arg0);
	exit(E_USER);
}

bomb()
{
	RPCLGoodbye();
	exit(1);
}

main(argc, argv)
  char	*argv[];
{
	extern  int     optind;
	extern  char    *optarg;
	int		uid = getuid();
	int		cc, flag;
	vmpHdr_t	*hp;
	vmpError_t	*ep;
	Id_t		seq;

	arg0 = argv[0];
	CheckUID(arg0);

	hp = vBuildHdr(M_SHUTDOWN, seq = vGetSeq(), HdrNULL);
	ep = MSGPTR(hp, vmpError_t);
	ep->vn_error = E_DOWN;
	ep->vn_state = 0;
	ep->vn_msg[0] = 0;
	while ((cc = getopt(argc, argv, "irm:")) != EOF) {
		switch (cc) {
		    case 'i':
			ep->vn_state |= SH_WAIT;
			break;
		    case 'r':
			ep->vn_state |= SH_RESTART;
			break;
		    case 'm':
			(void)strncpy(ep->vn_msg, optarg, LINELEN-1);
			break;
		    default:
			usage();
			break;
		}
	}
	if (argc - optind > 0)
		usage();

	nLogInit(arg0, bomb);
	nLogInitStderr(EL_ERROR1|EL_STATUS1);

	flag = 0;
	RPCLInit(M_CONSOLE, &flag);
	RPCLSend(hp, 1);

	if ((hp = RPCLRecv("shutdown")) == NULL) {
		vm_prerr(stderr);
		goto done;
	}
	if (hp->vh_seq != seq)
		nLogMsg(EL_ERROR1, 0, "bogus seq: %d/%d", seq, hp->vh_seq);

	switch (hp->vh_type) {
	    case M_SHUTDOWN:
		ep = MSGPTR(hp, vmpError_t);
		if (ep->vn_error)
			nLogMsg(EL_STATUS1, 0, 
				"(previous idle downs issued: %d)",
				ep->vn_error);
		if (ep->vn_state & SH_WAIT)
			nLogMsg(EL_STATUS1, 0, 
				"shutdown-when-idle scheduled %s",
				(ep->vn_state & SH_RESTART ? 
					"(restart will follow)" : ""));
		else
			nLogMsg(EL_STATUS1, 0, "shutdown succeeded %s",
				(ep->vn_state & SH_RESTART ? 
				"(restart will follow)" : ""));
		break;
	    case M_VERROR:
		ep = MSGPTR(hp, vmpError_t);
		nLogMsg(EL_ERROR1, 0, "shutdown failed: %s", ep->vn_msg);
		goto done;
	    default:
		nLogMsg(EL_ERROR1, 0, "unexpected reply to M_SHUTDOWN: %s",
		  vHdrStr(hp));
		goto done;
	}

done:
	RPCLGoodbye();
	return 0;
}
