/*
 *  Volume Manager
 *
 *  rp_clnt.h: client structures; needs vm_{ipc}.h included before it
 *
 * $Header: /Volumes/TempStorage/repos/netbsd/othersrc/nastore/volman/srvr/master/rp_clnt.h,v 1.1.1.1 2000-02-28 02:18:28 wrstuden Exp $
 */

#ifndef	_CLIENT_
#define	_CLIENT_


/*
 *  Client_t: one of these is created for each client connection
 *	(including RCs). It represents a unique (uid/pid) pair
 *
 *	(don't store gid; can be found from getgroups() when needed)
 */
typedef struct Client {
	int	c_host;			/* index in Host_t array	*/
	int	c_id;			/* index in Client_t array	*/
	int	c_pid;			/* process ID			*/
	int	c_uid;			/* user ID			*/
	IPC_t	*c_ipcp;		/* ipc-specific struct		*/
	Id_t	c_fileid;		/* file id used for passing key	*/
	int	c_flags;		/* client flags			*/
	QHead_t	c_cvrq;			/* head of Client VolReq Queue	*/
	QHead_t	c_ridq;			/* head of Client reservation Queue */
	time_t	c_time;			/* time when M_HELLO was sent   */
} Client_t;

/* #defines for c_flags */
#define	CL_EXIST	0x0001		/* client struct refers to a client */
#define	CL_SHUTDOWN	0x0002		/* this process needs to be shutdown */
#define	CL_PRIO		0x0004		/* Use a reserved connection if needed*/

/* #defines for accessing ClientQ - irrelevant if using array for Clients */
#define EnqueueClient(clientp)	ENQUEUE(clientp, &ClientQ, c_cq, Client_t)
#define	DequeueClient(clientp)	DEQUEUE(clientp, &ClientQ, c_cq, Client_t)
#define CLHEAD(qhead)	((Client_t *) (qhead).q_head)
#define NEXTCL(qlink)	((Client_t *) (qlink).q_next)

/* #defines for accessing ReservQ */
#define EnqueueReserv(clientp)	ENQUEUE(clientp, &ReservQ, c_cq, Client_t)
#define	DequeueReserv(clientp)	DEQUEUE(clientp, &ReservQ, c_cq, Client_t)


#endif	/* _CLIENT_ */
