#ifndef lint
static char rcsid[] = "$Header: /Volumes/TempStorage/repos/netbsd/othersrc/nastore/volman/srvr/master/voltimer.c,v 1.1.1.1 2000-02-28 02:18:29 wrstuden Exp $";
#endif

/*
 *  Volume Manager
 *
 *  voltimer.c: Volume Manager support function
 *
 */

#include <stdio.h>
#include <signal.h>
#include <time.h>

#ifdef EXTERN
# undef EXTERN
#endif
#define EXTERN

#include "srv_space.h"

done()
{
	exit(1);
}

main(argc, argv)
  char	*argv[];
{
	int	err, flag, interval = 0;
	char	buf[100];

	/*
	 *  get out of the way in case core is dumped
	 */
	chdir("/tmp");
	if (argc == 2)
		interval = atoi(argv[1]);
	if (interval <= 0) {
		fprintf(stderr, "usage: %s SECONDS\n", argv[0]);
		exit(7);
	}

	vInitDirNames();
	sprintf(buf, "%s_%d", argv[0], getpid());
	nLogInit(buf, done);
	nLogInitFile(vLogFile, EL_LEVEL, 0, NULL);
	nLogInitConsole(rp_syslog, EL_CONSOLE0, EL_LEVEL);
	flag = 0;
	RPCLInit(M_TIMERD, &flag);
	if (signal(SIGINT, (void (*) ()) done) == (void *)-1)
		nLogMsg(EL_FATAL|EL_SYS, 0, "signal SIGINT");
	err = Timer(interval);	/* returns when a write to the RP fails */
	return (err);
}


/*
 *  Timer():
 */
Timer(secs)
{
	char		buf[PKTSIZ(vmpTimer_t)];
	vmpHdr_t	*hp;
	vmpTimer_t	*tp;
	int		err;
	time_t		theTime;

	hp = vBuildHdr(M_TIMER, NOSEQ, (vmpHdr_t *)buf);
	tp = MSGPTR(hp, vmpTimer_t);

	for (;;) {
		unsigned	sleep();

		sleep(secs);
		time(&theTime);
		tp->vt_time = theTime;
		RPCLSend(hp, 1);
	}
}
