/*
**  "Media Changer" Repository Controller
**
**      ch_locate.c:  Look up vsn & check info
*/
#include "chrc.h"

int
ch_locate(RCReq_t *reqp)
{
	char		*id = "ch_locate";
	char		*vsnp = (char *)&reqp->rr_vsn;
	ch_stat_t	*slotp;

	/*
	**	get/check slot
	*/
	slotp = ch_getvsn(vsnp);
	if (slotp == NULL) {
		VMError = E_INTERNAL;
		nLogMsg(EL_CODE|EL_ERROR1, id, "%.*s not found", VSNLEN, vsnp);
		return(1);
	}
	if ((slotp->stat.ces_flags & CESTATUS_FULL) == 0) {
		VMError = E_INTERNAL;
		nLogMsg(EL_CODE|EL_ERROR1, id, "%.*s: slot empty", 
							VSNLEN, vsnp);
		return(1);
	}
	if (strncmp(vsnp, slotp->stat.ces_pvoltag.cv_tag, VSNLEN)) {
		VMError = E_INTERNAL;
		nLogMsg(EL_CODE|EL_ERROR1, id, "%.*s: %s in slot",
					VSNLEN, vsnp,
					slotp->stat.ces_pvoltag.cv_tag);
		return(1);
	}
	reqp->rr_slotp = slotp;
	return(0);
}
