/*
**  "Media Changer" Repository Controller
**
**	ch_mount.c:  Mount a vsn (location & target drive already known)
*/

#include "chrc.h"


extern DevEnt_t		*DriveArray;

int			CHmounted = 0;

int
ch_mount(RCReq_t *reqp)
{
	char		*id = "ch_mount";
	ch_mov_t	req;
	int		sltime;

nLogMsg(EL_STATUS1, id, " bitdrv %d  drive %d", reqp->rr_drive,
reqp->rr_chdrvp->index);
nLogMsg(EL_STATUS1, id, "------------");

	/*
	**	Make sure that the source & drive elements are accessible,
	**		in case some hardware glitch has arisen.
	**	Verify full/empty state as long as we're at it.
	*/
	if (get_elt_status(reqp->rr_slotp, id, "slot"))
		return (1);
	if ((reqp->rr_slotp->stat.ces_flags & CESTATUS_FULL) == 0)
		nLogMsg(EL_FATAL, id, "slot %d is empty",
					reqp->rr_slotp->index);

	if (get_elt_status(reqp->rr_chdrvp, id, "drive"))
		return (1);
	if (reqp->rr_chdrvp->stat.ces_flags & CESTATUS_FULL)
		nLogMsg(EL_FATAL, id, "drive %d is full",
					reqp->rr_chdrvp->index);

	/*
	**	build move cmd & execute
	*/
	bzero((void *)&req, sizeof (req));
	req.cm_fromtype = CHET_ST;
	req.cm_fromunit = reqp->rr_slotp->index;
	req.cm_totype = CHET_DT;
	req.cm_tounit = reqp->rr_chdrvp->index;

	nLogMsg(EL_STATUS2, 0, "MOUNT %.*s_%d slot %d -> drive %d (%s)", 
				VSNLEN, &reqp->rr_vsn, reqp->rr_seq,
				reqp->rr_slotp->index,
				reqp->rr_chdrvp->index, 
				DriveArray[reqp->rr_drive].de_name);

	if (ioctl(changer_fd, CHIOMOVE, &req)) {
		VMError = E_SYS;
		nLogMsg(EL_CODE|EL_SYS, id, "ioctl(CHIOMOVE)");
		return(1);
	}
	CHmounted++;
nLogMsg(EL_STATUS1, id, "------------ mounted (30 seconds delay)");
	sltime = 30;
	do { sltime = sleep(sltime); } while (sltime > 0);
	return(0);
}

