/*
**	Changer" Repository Controller
*/

#include "chrc.h"

extern DevEnt_t		*DriveArray;


/*
**  ch_rawunmount() - raw cmd to unmount vsn
*/
int
ch_rawunmount(ch_stat_t *drivep, ch_stat_t *slotp)
{
	char		*id = "ch_rawunmount";
	ch_mov_t	req;

	/*
	**	build move cmd & execute
	*/
	bzero((void *)&req, sizeof(req));
	req.cm_fromtype = CHET_DT;
	req.cm_fromunit = drivep->index;
	req.cm_totype = CHET_ST;
	req.cm_tounit = slotp->index;

nLogMsg(EL_STATUS1, id, "ioctl.. drive %d -> slot %d", 
drivep->index, slotp->index);
	if (ioctl(changer_fd, CHIOMOVE, &req)) {
		VMError = E_SYS;
		nLogMsg(EL_CODE|EL_SYS, id, "ioctl(CHIOMOVE)");
		return(1);
	}
nLogMsg(EL_STATUS1, id, "ioctl ok");
	return(0);
}

/*
**  ch_unmount() - unmount vsn in request struct
*/
int
ch_unmount(RCReq_t *reqp)
{
	char	*id = "ch_unmount";

nLogMsg(EL_STATUS1, id, "msg %*.*s %d", VSNLEN,VSNLEN, &reqp->rr_vsn,reqp->rr_drive);
	/*
	**	Make sure that the drive & slot elements are accessible,
	**		in case some hardware glitch has arisen.
	**	Verify full/empty state as long as we're at it.
	*/
	if (get_elt_status(reqp->rr_chdrvp, id, "drive"))
		return (1);
	if ((reqp->rr_chdrvp->stat.ces_flags & CESTATUS_FULL) == 0)
		nLogMsg(EL_FATAL, id,
		    "UNMOUNT %*.*s_%d (%s)- already unmounted?",
		    VSNLEN, VSNLEN, &reqp->rr_vsn, reqp->rr_seq,
		    DriveArray[reqp->rr_drive].de_name);
	if (get_elt_status(reqp->rr_slotp, id, "slot"))
		return (1);
	if ((reqp->rr_slotp->stat.ces_flags & CESTATUS_FULL) != 0)
		nLogMsg(EL_FATAL, "ch_unmount", "slot %d is full",
					reqp->rr_slotp->index);
	
	nLogMsg(EL_STATUS2, 0, "UNMOUNT %*.*s_%d (%s)",
				VSNLEN,VSNLEN, &reqp->rr_vsn, reqp->rr_seq,
				DriveArray[reqp->rr_drive].de_name);
	return (ch_rawunmount(reqp->rr_chdrvp, reqp->rr_slotp));
}

