/*
**  ibm_tables.c - string lookups
*/

#include "vm_space.h"
#include "mtlibio.h"

CodeString_t	IBMCompletionCodeTab[] = {
	MTCC_COMPLETE,		"Complete - No error",
	MTCC_COMPLETE_VISION,	"Complete - Vision not operational",
	MTCC_COMPLETE_NOTREAD,	"Complete - VOLSER not readable",
	MTCC_COMPLETE_CAT,	"Complete - Cat. assign. not changed",
	MTCC_CANCEL_PROGREQ,	"Cancelled - Program request",
	MTCC_CANCEL_ORDERSEQ,	"Cancelled - Order sequence",
	MTCC_CANCEL_MANMODE,	"Cancelled - Manual mode",
	MTCC_FAILED_HARDWARE,	"Failed - Hardware",
	MTCC_FAILED_VISION,	"Failed - Vision not operational",
	MTCC_FAILED_NOTREAD,	"Failed - VOLSER not readable",
	MTCC_FAILED_INACC,	"Failed - Volume inaccessible",
	MTCC_FAILED_MISPLACED,	"Failed - Volume misplaced",
	MTCC_FAILED_CATEMPTY,	"Failed - Category empty",
	MTCC_FAILED_MANEJECT,	"Failed - Volume manually ejected",
	MTCC_FAILED_INVENTORY,	"Failed - Vol no longer in inventory",
	MTCC_FAILED_NOTAVAIL,	"Failed - Device no longer available",
	MTCC_FAILED_LOADFAIL,	"Failed - Permanent Load failure",
	MTCC_FAILED_DAMAGED,	"Failed - Load Failure-Cart damaged",
	MTCC_COMPLETE_DEMOUNT,	"Complete - Demount",
	MTCC_NO_LMCP,		"LMCP is not configured",
	MTCC_NOT_CMDPORT_LMCP,	"Device is not command-port LMCP",
	MTCC_NO_DEV,		"Device is not configured",
	MTCC_NO_DEVLIB,		"Device is not in library",
	MTCC_NO_MEM,		"Not enough memory",
	MTCC_DEV_INUSE,		"Device is in use",
	MTCC_IO_FAILED,		"I/O failed",
	MTCC_DEV_INVALID,	"Device is invalid",
	MTCC_NOT_NTFPORT_LMCP,	"Device not notification-port LMCP",
	MTCC_INVALID_SUBCMD,	"Invalid subcmd parameter",
	MTCC_LIB_NOT_CONFIG,	"No library device is configured",
	MTCC_INTERNAL_ERROR,	"Internal error",
	MTCC_INVALID_CANCELTYPE,"Invalid cancel type",
	MTCC_NOT_LMCP,		"Not an LMCP device",
	MTCC_LIB_OFFLINE,	"Library offline to host",
	MTCC_UNDEFINED,		"Undefined completion code",
	0,			"",
};

char *
IBM_CC(int code)
{
	return(nCodeToStr(code, IBMCompletionCodeTab));
}


CodeString_t	IBM_VolStateTab[] =	{
	MT_VSLI,	"present but inaccessible",
	MT_VSMQ,	"mounted or queued for mount",
	MT_VSEP,	"eject pending",
	MT_VSPE,	"eject in progress",
	MT_VSM,		"misplaced!",
	MT_VSUU,	"unreadable external label",
	MT_VSMM,	"used during manual mode (?)",
	MT_VSME,	"manually ejected",
	0,		"",
};

char *
IBM_VolState(char code)
{
	return(nCodeToStr((int)code, IBM_VolStateTab));
}

CodeString_t		IBM_InfoTypeTab[] = {
	MT_QVD,		"Query Volume Data",
	MT_QLD,		"Query Library Data",
	MT_QSD,		"Query Statistical Data",
	MT_QID,		"Query inventory Data",
	MT_QCID,	"Query category inventory Data",
	MT_QDD,		"Query device Data",
	MT_QEVD,	"Query Expanded volume data",
	MT_QIVCD,	"Query Inventory Volume Count Data",
	MT_QRCL,	"Query Reserved Category List",
	MT_QCAL,	"Query Category Attribute List",
	0,		"",
};

char *
IBM_InfoType(char code)
{
	return(nCodeToStr((int)code, IBM_InfoTypeTab));
}

CodeString_t	IBM_LibStateTab[] = {
	MT_LIB_AOS,	"Automated Operational State",
	MT_LIB_POS,	"Paused Operational State",
	MT_LIB_MMOS,	"Manual Mode Operational State",
	MT_LIB_DO,	"Degraded Operation",
	MT_LIB_SEIO,	"Safety Enclose Interlock Open",
	MT_LIB_VSNO,	"Vision system Non-Operational",
	MT_LIB_OL,	"Offline",
	MT_LIB_IR,	"Intervention Required",
	MT_LIB_CK1,	"Library Manager Check 1 Condition",
	MT_LIB_SCF,	"All Storage Cells Full",
	MT_LIB_OCV,	"Out of Cleaner Volumes",
	MT_LIB_DWD,	"Dual Write Disabled",
	MT_LIB_EA,	"Environmental Alert -- smoke detected",
	MT_LIB_MMMOS,	"Managed Manual Mode Operational State",
	0,		"",
};

char *
IBM_LibState(int code)
{
	return(nCodeToStr(code, IBM_LibStateTab));
}
