#include <fcntl.h>
#include <sys/types.h>
#include "vltlib.h"
#include "vconfig.h"

/*
 * This structure defines each section.
 */

struct panel {
        char   panel_name[4];	/* ASCII Name */
	char   num_rows;	/* Number of rows in this section */
	char   num_cols;	/* Number of columns in this section */
};

#define TAPES 135000

struct 	panel	*sp;
int	lrow, lslot;

struct	panel	parray[] = {

         { "A8",  16, 50 },
	 { "A9",  16, 50 },
	 { "A10", 16, 50 },
	 { "A11", 16, 10 },
	 { "A12", 16, 50 },
	 { "A13", 16, 50 },
	 { "A14", 16, 50 },
 	 { "A15", 16, 50 },

	 { "B0",   16, 50 },
	 { "B1",   16, 50 },
	 { "B2",   16, 50 },
	 { "B3",   16, 50 },
	 { "B4",   16, 50 },
	 { "B5",   16, 50 },
	 { "B6",   16, 50 },
	 { "B7",   16, 10 },
	 { "B8",   16, 50 },
	 { "B9",   16, 50 },
	 { "B10", 16, 50 },
	 { "B11", 16, 10 },
	 { "B12", 16, 50 },
	 { "B13", 16, 50 },
	 { "B14", 16, 50 },
	 { "B15", 16, 50 },	 	 

	 { "C0",   16, 50 },
	 { "C1",   16, 50 },
	 { "C2",   16, 50 },
	 { "C3",   16, 50 },
	 { "C4",   16, 50 },
	 { "C5",   16, 50 },
	 { "C6",   16, 50 },
	 { "C7",   16, 10 },
	 { "C8",   16, 50 },
	 { "C9",   16, 50 },
	 { "C10", 16, 50 },
	 { "C11", 16, 10 },
	 { "C12", 16, 50 },
	 { "C13", 16, 50 },
	 { "C14", 16, 50 },
	 { "C15", 16, 50 },	 	 

	 { "D0",   16, 50 },
	 { "D1",   16, 50 },
	 { "D2",   16, 50 },
	 { "D3",   16, 50 },
	 { "D4",   16, 50 },
	 { "D5",   16, 50 },
	 { "D6",   16, 50 },
	 { "D7",   16, 10 },
	 { "D8",   16, 50 },
	 { "D9",   16, 50 },
	 { "D10", 16, 50 },
	 { "D11", 16, 10 },
	 { "D12", 16, 50 },
	 { "D13", 16, 50 },
	 { "D14", 16, 50 },
	 { "D15", 16, 50 },	 	 

	 { "E0",   16, 50 },
	 { "E1",   16, 50 },
	 { "E2",   16, 50 },
	 { "E3",   16, 50 },
	 { "E4",   16, 50 },
	 { "E5",   16, 50 },
	 { "E6",   16, 50 },
	 { "E7",   16, 10 },
	 { "E8",   12, 44 },
	 { "E9",   12, 44 },
	 { "E10", 12, 44 },
	 { "E11", 12, 44 },
	 { "E12", 12, 44 },

	 { "F0",   12, 44 },
	 { "F1",   12, 44 },
	 { "F2",   12, 44 },
	 { "F3",   12, 44 },
	 { "F4",   12, 44 },
	 { "F5",   12, 44 },
	 { "F6",   12, 44 },
	 { "F7",   12, 44 },
	 { "F8",   12, 44 },
	 { "F9",   12, 44 },

	 { "G0",   12, 44 },
	 { "G1",   12, 44 },
	 { "G2",   12, 44 },
	 { "G3",   12, 44 },
	 { "G4",   12, 44 },
	 { "G5",   12, 44 },
	 { "G6",   12, 44 },
	 { "G7",   12, 44 },
	 { "G8",   12, 44 },
	 { "G9",   12, 44 },

	 { "H0",   12, 44 },
	 { "H1",   12, 44 },
	 { "H2",   12, 44 },
	 { "H3",   12, 44 },
	 { "H4",   12, 44 },
	 { "H5",   14, 20 },
	 { "H6",   14, 20 },
	 { "H7",   14, 20 },
	 { "H8",   14, 20 },
	 { "H9",   14, 20 },
	 { "H10", 14, 20 },
	 { "H11", 14, 20 },
	 { "H12", 14, 20 },
	 { "H13", 14, 20 },
	 { "H14", 14, 20 },
 
	 { "I0",   14, 20 },
 	 { "I1",   14, 20 },
	 { "I2",   14, 20 },
	 { "I3",   14, 20 },
	 { "I4",   14, 20 },
	 { "I5",   14, 20 },
	 { "I6",   14, 20 },
	 { "I7",   14, 20 },
	 { "I8",   14, 20 },
	 { "I9",   14, 20 },
	 { "I10", 14, 20 },
	 { "I11", 14, 20 },
	 { "I12", 14, 20 },
	 { "I13", 14, 20 },
	 { "I14", 14, 20 },
	 { "I15", 14, 20 },
	 { "I16", 14, 20 },
	 { "I17", 14, 20 },
	 { "I18", 14, 20 },
	 { "I19", 14, 20 },
 
	 { "J0",   14, 20 },
 	 { "J1",   14, 20 },
	 { "J2",   14, 20 },
	 { "J3",   14, 20 },
	 { "J4",   14, 20 },
	 { "J5",   14, 20 },
	 { "J6",   14, 20 },
	 { "J7",   14, 20 },
	 { "J8",   14, 20 },
	 { "J9",   14, 20 },
	 { "J10", 14, 20 },
	 { "J11", 14, 20 },
	 { "J12", 14, 20 },
	 { "J13", 14, 20 },
	 { "J14", 14, 20 },
	 { "J15", 14, 20 },
	 { "J16", 14, 20 },
	 { "J17", 14, 20 },
	 { "J18", 14, 20 },
	 { "J19", 14, 20 },
 
	 { "K0",   14, 20 },
	 { "K1",   14, 20 },	 
	 { "K2",   14, 20 },
	 { "K3",   14, 20 },
	 { "K4",   14, 20 },
	 { "K5",   14, 20 },
	 { "K6",   14, 20 },
	 { "K7",   14, 20 },
	 { "K8",   14, 20 },
	 { "K9",   14, 20 },
	 { "K10", 14, 20 },
	 { "K11", 14, 20 },
	 { "K12", 14, 20 },
	 { "K13", 14, 20 },
	 { "K14", 14, 20 },
	 { "K15", 14, 20 },
	 { "K16", 14, 20 },
	 { "K17", 14, 20 },
	 { "K18", 14, 20 },
	 { "K19", 14, 20 },

	 { "L0",   14, 20 },
  	 { "L1",   14, 20 },
	 { "L2",   14, 20 }, 
	 { "L3",   14, 20 }, 
	 { "L4",   14, 20 }, 
	 { "L5",   14, 20 }, 
	 { "L6",   14, 20 }, 
	 { "L7",   14, 20 }, 
	 { "L8",   14, 20 },
  	 { "L9",   14, 20 },
	 { "L10", 14, 20 },
	 { "L11", 14, 20 }, 
	 { "L12", 14, 20 }, 
	 { "L13", 14, 20 }, 
	 { "L14", 14, 20 }, 
	 { "L15", 14, 20 }, 

 	 { "M0",   14, 20 },
  	 { "M1",   14, 20 },
	 { "M2",   14, 20 }, 
	 { "M3",   14, 20 }, 
	 { "M4",   14, 20 }, 
	 { "M5",   14, 20 }, 
	 { "M6",   14, 20 }, 
	 { "M7",   14, 20 }, 
	 { "M8",   14, 20 },
  	 { "M9",   14, 20 },
	 { "M10", 14, 20 },
	 { "M11", 14, 20 }, 
	 { "M12", 14, 20 }, 
	 { "M13", 14, 20 }, 
	 { "M14", 14, 20 }, 
	 { "M15", 14, 20 }, 

	 { "N0",   14, 20 },
  	 { "N1",   14, 20 },
	 { "N2",   14, 20 }, 
	 { "N3",   14, 20 }, 
	 { "N4",   14, 20 }, 
	 { "N5",   14, 20 }, 
	 { "N6",   14, 20 }, 
	 { "N7",   14, 20 }, 
	 { "N8",   14, 20 },
  	 { "N9",   14, 20 },
	 { "N10", 14, 20 },
	 { "N11", 14, 20 }, 
	 { "N12", 14, 20 }, 
	 { "N13", 14, 20 }, 
	 { "N14", 14, 20 }, 
	 { "N15", 14, 20 }, 

	 { "O0",   14, 20 },
  	 { "O1",   14, 20 },
	 { "O2",   14, 20 }, 
	 { "O3",   14, 20 }, 
	 { "O4",   14, 20 }, 
	 { "O5",   14, 20 }, 
	 { "O6",   14, 20 }, 
	 { "O7",   14, 20 }, 
	 { "O8",   14, 20 },
  	 { "O9",   14, 20 },
	 { "O10", 14, 20 },
	 { "O11", 14, 20 }, 
	 { "O12", 14, 20 }, 
	 { "O13", 14, 20 }, 
	 { "O14", 14, 20 }, 
	 { "O15", 14, 20 }, 

	 { "P0",   14, 20 },
  	 { "P1",   14, 20 },
	 { "P2",   14, 20 }, 
	 { "P3",   14, 20 }, 
	 { "P4",   14, 20 }, 
	 { "P5",   14, 20 }, 
	 { "P6",   14, 20 }, 
	 { "P7",   14, 20 }, 
	 { "P8",   14, 20 },
  	 { "P9",   14, 20 },
	 { "P10", 14, 20 },
	 { "P11", 14, 20 }, 
	 { "P12", 14, 20 }, 
	 { "P13", 14, 20 }, 
	 { "P14", 14, 20 }, 
	 { "P15", 14, 20 }, 

	 { "Q0",   14, 20 },
  	 { "Q1",   14, 20 },
	 { "Q2",   14, 20 }, 
	 { "Q3",   14, 20 }, 
	 { "Q4",   14, 20 }, 
	 { "Q5",   14, 20 }, 
	 { "Q6",   14, 20 }, 
	 { "Q7",   14, 20 }, 
	 { "Q8",   14, 20 },
  	 { "Q9",   14, 20 },
	 { "Q10", 14, 20 },
	 { "Q11", 14, 20 }, 
	 { "Q12", 14, 20 }, 
	 { "Q13", 14, 20 }, 
	 { "Q14", 14, 20 }, 
	 { "Q15", 14, 20 }, 

	 { "R0",   14, 20 },
  	 { "R1",   14, 20 },
	 { "R2",   14, 20 }, 
	 { "R3",   14, 20 }, 
	 { "R4",   14, 20 }, 
	 { "R5",   14, 20 }, 
	 { "R6",   14, 20 }, 
	 { "R7",   14, 20 }, 
	 { "R8",   14, 20 },
  	 { "R9",   14, 20 },
	 { "R10", 14, 20 },
	 { "R11", 14, 20 }, 
	 { "R12", 14, 20 }, 
	 { "R13", 14, 20 }, 
	 { "R14", 14, 20 }, 
	 { "R15", 14, 20 }, 

 	 { "S0",   14, 20 },
  	 { "S1",   14, 20 },
	 { "S2",   14, 20 }, 
	 { "S3",   14, 20 }, 
	 { "S4",   14, 20 }, 
	 { "S5",   14, 20 }, 
	 { "S6",   14, 20 }, 
	 { "S7",   14, 20 }, 
	 { "S8",   14, 20 },
  	 { "S9",   14, 20 },
	 { "S10", 14, 20 },
	 { "S11", 14, 20 }, 
	 { "S12", 14, 20 }, 
	 { "S13", 14, 20 }, 
	 { "S14", 14, 20 }, 
	 { "S15", 14, 20 }, 

	 { "T0",   14, 20 },
  	 { "T1",   14, 20 },
	 { "T2",   14, 20 }, 
	 { "T3",   14, 20 }, 
	 { "T4",   14, 20 }, 
	 { "T5",   14, 20 }, 
	 { "T6",   14, 20 }, 
	 { "T7",   14, 20 }, 
	 { "T8",   14, 20 },
  	 { "T9",   14, 20 },
	 { "T10", 14, 20 },
	 { "T11", 14, 20 }, 
	 { "T12", 14, 20 }, 
	 { "T13", 14, 20 }, 
	 { "T14", 14, 20 }, 
	 { "T15", 14, 20 }, 

 	 { "U0",   14, 20 },
  	 { "U1",   14, 20 },
	 { "U2",   14, 20 }, 
	 { "U3",   14, 20 }, 
	 { "U4",   14, 20 }, 
	 { "U5",   14, 20 }, 
	 { "U6",   14, 20 }, 
	 { "U7",   14, 20 }, 
	 { "U8",   14, 20 },
  	 { "U9",   14, 20 },
	 { "U10", 14, 20 },
	 { "U11", 14, 20 }, 
	 { "U12", 14, 20 }, 
	 { "U13", 14, 20 }, 
	 { "U14", 14, 20 }, 
	 { "U15", 14, 20 }, 

	 { "V0",   14, 20 },
  	 { "V1",   14, 20 },
	 { "V2",   14, 20 }, 
	 { "V3",   14, 20 }, 
	 { "V4",   14, 20 }, 
	 { "V5",   14, 20 }, 
	 { "V6",   14, 20 }, 
	 { "V7",   14, 20 }, 
	 { "V8",   14, 20 },
  	 { "V9",   14, 20 },
	 { "V10", 14, 20 },
	 { "V11", 14, 20 }, 
	 { "V12", 14, 20 }, 
	 { "V13", 14, 20 }, 
	 { "V14", 14, 20 }, 
	 { "V15", 14, 20 }, 

	 { "W0",   14, 20 },
	 { "W1",   14, 20 },
	 { "W2",   14, 20 }, 
	 { "W3",   14, 20 }, 
	 { "W4",   14, 20 }, 
	 { "W5",   14, 20 }, 
	 { "W6",   14, 20 }, 
	 { "W7",   14, 20 }, 
	 { "W8",   14, 20 },
  	 { "W9",   14, 20 },
	 { "W10", 14, 20 },
	 { "W11", 14, 20 }, 
	 { "W12", 14, 20 }, 
	 { "W13", 14, 20 }, 
	 { "W14", 14, 20 }, 
	 
	 { "", 0, 0 }

};
 
int		fd;		/* dbase file discriptor */
vsnrec_t	vsnbuf;		/* ALL info on vsn */
vaultrec_t	*vrp;

main()
{
	int		ret;
	locrec_t	*lrp;
	time_t		now;
	int		i;
	char		vsn[VSNLEN+1];

	/*
	 *  lock the database
	 */

	if ((ret=open(DB_LOCK, O_CREAT|O_EXCL, 0600)) == -1) {
		perror(DB_LOCK);
		exit(1);
	}
	close(ret);

	if ((fd = open(DB_VSN_TBL, O_RDWR|O_CREAT|O_EXCL, 0600))== -1) {
		perror(DB_VSN_TBL);
		unlink(DB_LOCK);
		exit(1);
	}

	now = time((time_t *)0);

	/*
	 *  set up buffer
	 */

	memset(&vsnbuf, ' ', sizeof(vsnbuf));
	vsnbuf.v_lastloc = '0';
	vsnbuf.end = '\n';
	lrp = &vsnbuf.v_loc[0];
	strcpy(lrp->l_date, ctime(&now), DATELEN);
	lrp->l_date[DATELEN] = ' ';
	lrp->l_type = VAULT;
	vrp = &lrp->l_field.vu_vault;
	
	sp = parray;		/* start of array */
	lrow = 0;
	lslot = 0;

	for (i = 37000; i < 100000; i++) {
		sprintf(vsn, "M%05ld", i);
		db_write(vsn);
	}
	printf("Done Part1\n");
	
	for (i = 53480; i <= 58999; i++) {
		sprintf(vsn, "N%05ld", i);
		db_write(vsn);
	}
	printf("Done Part2\n");
	
	for (i = 0; i <= 999; i++) {
		sprintf(vsn, "H%05ld", i);
		db_write(vsn);
	}
	printf("Done Part3\n");
	
	for (i = 0; i <= 8999; i++) {
		sprintf(vsn, "C%05ld", i);
		db_write(vsn);
	}
	printf("Done Part4\n");
	
	for (i = 0; i <= 2999; i++) {
		sprintf(vsn, "B%05ld", i);
		db_write(vsn);
	}
	printf("Done Part5\n");
	
	for (i = 0; i <= 53479; i++) {
		sprintf(vsn, "N%05ld", i);
		db_write(vsn);
	}
	printf("Done Part6\n");
	fsync(fd);
	close(fd);
	unlink(DB_LOCK);
}

db_write(vsn)
 char	*vsn;
{
	memcpy(vsnbuf.v_vsn, vsn, VSNLEN);
	memset(vrp, ' ', sizeof(vaultrec_t));
	memcpy(vrp->vr_section, sp->panel_name, strlen(sp->panel_name));
	sprintf(vrp->vr_row, "%*d", INTLEN, lrow);
	vrp->vr_row[INTLEN] = ' ';
	sprintf(vrp->vr_slot, "%*d", INTLEN, lslot++);
	vrp->vr_slot[INTLEN] = ' ';

	if (write(fd, vsnbuf, sizeof(vsnrec_t)) < sizeof(vsnrec_t)) {
		perror("write");
		exit(1);
	}

	if (lslot == sp->num_cols) {
		lslot = 0;
		lrow++;
		if (lrow == sp->num_rows) {
			lrow = 0;
			sp++;
			if (sp->panel_name[0] == '\0')
				printf("out of vault space\n");
		}
	}
}
