#include	<stdio.h>
#include	<fcntl.h>
#include	<unistd.h>
#include	<signal.h>
#include	<sys/types.h>
#include	<sys/stat.h>

#include	"vconfig.h"

char	clear[] = "\033[H\033[2J";
int	fd;

redraw()
{
	int	len;
	char	buf[4096];

	if (lseek(fd, (off_t)0, SEEK_SET) == -1) {
		perror("lseek");
		sleep(20);
		exit(1);
	}
	write(fileno(stdout), clear, sizeof(clear));
	while ((len = read(fd, buf, sizeof(buf))) > 0) {
		if (write(fileno(stdout), buf, len) != len) {
			perror("write");
			sleep(20);
			exit(1);
		}
	}
	if (len == -1) {
		perror("read");
		sleep(20);
		exit(1);
	}
}

main()
{
	struct	stat	sb;
	time_t	last = 0;

	if ((fd=open(DISPLAYFILE, O_RDONLY)) == -1) {
		perror(DISPLAYFILE);
		sleep(20);
		exit(1);
	}

	signal(SIGWINCH, redraw);

	for (;;) {
		if (fstat(fd, &sb) == -1) {
			perror("fstat");
			sleep(20);
			exit(1);
		}
		if (sb.st_nlink == 0)
			break;

		if (last < sb.st_mtime) {
			redraw();
			last = sb.st_mtime;
		}
		sleep(5);
	}
	return 0;
}
