/*
 * TAPELIB.H 
 * Version 1.1 Beta 7/16/93
 * J. Musch
 */

#define TIMEOUT_INV	20
#define TIMEOUT_REQ	60
#define TIMEOUT_HLP	60
#define TIMEOUT_COMM	0

#define BEEP_VOL	NORMAL_VOL	
#define DEFAULT_VOL	NO_VOL

#define BEEP_MATCH	1	/* The various arguments to beep */
#define BEEP_ERROR	2
#define BEEP_QUERY	3
#define BEEP_DELTA	4

#define WIN_INV		1	/* The various screens used */
#define WIN_COMM	2
#define WIN_REQ		3
#define WIN_HELP	4

#define VSN_SIZE 6              /* MAX size of VSN */
#define SEC_SIZE 8              /* MAX size of section name */
#define ROW_SIZE 2
#define COL_SIZE 2
#define MAXLINE  16
#define MAXCOL	 21

#define  MAX_TRANSLOG 500
#define  MAX_REQLOG   500

#define TRX_IGN 0x00
#define TRX_ADD 0x01
#define TRX_DEL 0x02

#define PWR_LOBAT	(-1)
#define PWR_PWRUP	1
#define PWR_NODELTA	0

#define QUERY_BAD_POWER	(-1)
#define QUERY_YES	0
#define QUERY_NO	1

#define SECTION_ID     "NTL"
#define SECTION_ID_LEN (int)strlen(SECTION_ID)

/*
 * This structure defines each section.
 */
struct section {
    char   section_name[SEC_SIZE];     /* ASCII Name */
    char   section_bcid[8];    /* BAR CODE   */
    char   num_rows;            /* Number of rows in this section */
    char   num_cols;            /* Number of columns in this section */
    long   start;
};

struct tapes {
    char tapeid[VSN_SIZE];
    char flag;
};

#define INVALID   0
#define VALID     1
#define UPDATED   2
#define REQUESTED 4

void db_reset();
void db_left(), db_right(), db_up(), db_down(), db_return();
void db_redraw();
void rl_reset(), rl_disp(), rl_up(), rl_down(), rl_deque();
void beep(), purge_kbd(), delay();
void rl_sort(), trx_log_pack();

int comm(), get_record();
int rl_init(), rl_add(), rl_del();
int chsize();

long db_geom();

extern int redraw;
extern int trx_fd;
extern int volume;

extern long rl_que_length;
extern long translog_size;












