/*
**	This is the XDR file for the vault RPC's.
*/

const	LOCSIZE		=	53;
const	SECSIZE		=	8;
const	MESSAGESIZE	=	80;
const	HISTORY		=	3;

#if	defined(RPC_HDR)	/* we only want to test for VSNLEN in the .h */
%#if	!defined(VSNLEN)
#endif

const	VSNLEN		=	6;
struct vsn_t {
	char	v_vsn[VSNLEN];
};

#if	defined(RPC_HDR)
%#endif
#endif

enum	loctype	{
	unknown,
	vault,
	display
};

struct	vaultloc_t {
	char	Section[SECSIZE];
	int	Row;
	int	Slot;
};

union	location_t	switch(loctype tag) {
case	unknown:
	void;
case	vault:
	vaultloc_t	vault;
case	display:
	char		General[LOCSIZE];
};

struct	spacetime_t {
	long		when;
	location_t	where;
};

%#define	section	location_t_u.vault.Section
%#define	row	location_t_u.vault.Row
%#define	slot	location_t_u.vault.Slot
%#define	general	location_t_u.General
	
struct vsnloc_t {
	vsn_t		vsn;
	spacetime_t	location;
};

struct vsnhistory_t {
	vsn_t		vsn;
	spacetime_t	history[HISTORY];
};

struct vsnreq_t {
	vsn_t		vsn;
	char		message[MESSAGESIZE];
};
	
program	VAULTPROG {
	version	VAULTVERS {
		int		VAULT_UPDATE(vsnloc_t) = 1;
		int		VAULT_DELETE(vsn_t) = 2;
		spacetime_t	VAULT_QUERY(vsn_t) = 3;
		int		VAULT_REQUEST(vsnreq_t) = 4;
		int		VAULT_CANCEL(vsn_t) = 5;
	} = 1;
} = 0x20000999;
