#include <stdio.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/time.h>

#include "vmerror.h"
#include "vltlib.h"
#include "vconfig.h"

FILE	*displayfile = NULL;
extern	struct	displaylist	*displaylist;

/*
**	Open the display file
*/
 int
DisplayInit()
{
	displayfile = fopen(DISPLAYFILE, "w");
	if (displayfile == NULL)
		vLogMsg(EL_ERROR1|EL_SYS, "DisplayInit", DISPLAYFILE);
	return;
}

 void
DestroyDisplay()
{
	if (displayfile == NULL)
		return;

	fclose(displayfile);
	unlink(DISPLAYFILE);
	displayfile = NULL;
}

 void
DisplayList()
{
	struct	displaylist	*dp;
	spacetime_t		*stp;
	char	*locstr;
	int	line;

	if (displayfile == NULL)
		return;

	if (ftruncate(fileno(displayfile), (off_t)0) == -1) {
		vLogMsg(EL_ERROR1|EL_SYS, "DisplayList",
			"ftruncate failed");
		DestroyDisplay();
		return;
	}

	for (dp=displaylist; dp; dp=dp->dl_next) {
		stp = GetVsn(dp->dl_vsnreq.vsn);
		locstr = (stp == NULL) ?
			"NOT FOUND" :
			LocationString(&stp->where);

		fprintf(displayfile, "%.*s\t%.24s\t%.*s @ %s\t%s\n",
			sizeof(dp->dl_mach), dp->dl_mach,
			ctime(&dp->dl_time),
			VSNLEN, dp->dl_vsnreq.vsn, locstr,
			dp->dl_vsnreq.message);
	}
	fflush(displayfile);
}
