/*
 *  vvcons - NAStore Virtual Volume Manager console shutdown cmd
 *
 *	Bill Ross, NASA Ames, October 1997
 */

#include "vv_space.h"

char	*arg0 = NULL;


  static void
usage()
{
	fprintf(stderr, "usage: %s [msg]\n", arg0);
}

bomb()
{
	fprintf(stderr, "exiting\n");
	exit(1);
	return(1);	/* for compiler warning */
}

main(int argc, char *argv[])
{
	char		buf[VV_PKTSIZ(vvpError_t)];
	vvpHdr_t	*hp, *rhp;
	vvpError_t	*ep;
	int		cc;
	extern  int     optind;
	extern  char    *optarg;

	arg0 = argv[0];
#ifndef PURIFY
	if (getuid() != 0) {
		fprintf(stderr, "%s: must be root\n", arg0);
		exit(1);
	}
#endif
	nLogInit(arg0, bomb);
	nLogInitStderr(EL_ERROR1);
	VVCLInit(vvHost, VVM_CLIENT, RETRY_FATAL);

	hp = vvBuildHdr(VVM_SHUTDOWN, VVNOSEQ, (vvpHdr_t *)buf);
	ep = VV_MSGPTR(hp, vvpError_t);
	ep->vn_error = VVE_DOWN;
	ep->vn_msg[0] = 0;

	if (argc > 2)
		usage();
	if (argc == 2)
		(void)strncpy(ep->vn_msg, optarg, LINELEN-1);

	/*
	 *  msg is built - send it
	 */
	(void)VVCLSend(hp, 1);		/* dies if problem */

	/*
	 *  get response(s)
	 */
	rhp = VVCLRecv("response");	/* dies if problem */

	switch (rhp->vh_type) {
	    case VVM_SHUTDOWN:
		/*
		 *  success
		 */
		nLogMsg(EL_STATUS1, 0, "shutdown succeeded");
		exit(0);
	    case VVM_VVERROR:
		ep = VV_MSGPTR(rhp, vvpError_t);
		nLogMsg(EL_ERROR1, 0, "shutdown failed: %s", ep->vn_msg);
		exit(1);
	    default:
		nLogMsg(EL_ERROR1, 0, "unexpected response: %s", vvHdrStr(hp));
		exit(1);
	}
}
