#ifndef VV_CL_H
#define VV_CL_H

/*
 *  vv_cl.h - NAStore Virtual Volume Manager client include
 *
 *	Bill Ross, NASA Ames, October 1997
 */

#include "vv_space.h"

#define MAXVVNAMELEN	(VV_CLASSLEN+VV_SERIALLEN+1)
#define MAXVVERRLEN	(LINELEN+1)

extern char	vv_errstr[MAXVVERRLEN];

typedef struct vv_handle {
	int		v_magic;
	int		v_fd;
	int		v_writing;
	int		v_hdroffset;
	OFF_T		v_writable;
	OFF_T		v_reserve;
	char		v_name[MAXVVNAMELEN+1];
	VVInfo_t	v_info;
} vv_handle_t;


int		vv_init(char *hostname, int retry);
void 		vv_term();

char		*vv_handle2name(vv_handle_t *vhp);

vv_handle_t	*vv_openwrite(char *vid, char *classprefix, 
				OFF_T want2write, OFF_T reserve);
OFF_T		vv_tell(vv_handle_t *vhp);
OFF_T		vv_available(vv_handle_t *vhp);
ssize_t		vv_write(vv_handle_t *vp, void *bp, size_t len);
int		vv_startreserve(vv_handle_t *vp);


int		vv_close(vv_handle_t *vhp, int finish);

vv_handle_t	*vv_finish(char *vvname);

vv_handle_t	*vv_openread(char *vvname);
OFF_T		vv_lseek(vv_handle_t *vp, OFF_T offset, int whence);
ssize_t		vv_read(vv_handle_t *vp, void *data, size_t len);

VVInfo_t	*vv_info(char *name);
VVInfo_t	*vv_handle2info(vv_handle_t *vhp);

int		vv_recycle(char *name);

int		vv_destroyhandle(vv_handle_t **vhpP);

Vsn_t		*vv_vsninfo(char *vsnp);

#endif /* VV_CL_H */
