
/*
 *  note: changing MAXVSN can invalidate class portion of vvm dbase.
 *	MAXVSN must be in range 1..9; if more, update slot handling
 *	in vvm dbase.
 */

#define MAXVSN 2

/* TODO - could add poolgid to VsnT_t if using scratch pools was desired */

typedef struct VsnT {
	char	*vs_rc;		/* volman Repository Controller		    */
	char	*vs_voltype;	/* volman volume type (medium, capacity)    */
} VsnT_t;

typedef struct ClassInfo {
	char	*cs_name;	/* human-readable name			    */
	char	*cs_prefix;	/* prefix for VV names;			    */
				/* maximum len = VV_CLASSLEN		    */
	int	cs_flags;	/* attributes				    */
	OFF_T	cs_vvsize;	/* maximum size (bytes) allowed		    */
	OFF_T	cs_finishsize;	/* size at which it's ok to finish	    */
	int	cs_nvsns;	/* number of vsn types in class	(<=MAXVSN)  */
	VsnT_t	cs_vsns[MAXVSN];/* vsn type definitions	('slots')	    */
} Class_t;

/* attributes for cs_flags */

#define CS_FREEDISK	0x001	/* free disk space as soon as saved on tape */
#define CS_NONEW	0x100	/* create no new VV's in this class	    */

