/*
 *  NAStore Virtual Volume Manager
 *
 *  vv_error.h: Virtual Volume Manager errors
 *
 */

/*
 *  Error codes for VVError
 *	These are the (only) error codes the user sees,
 *	so they should be simple and high-level in nature.
 *	They can be supplemented with a descriptive string in nErrStr.
 *	Any changes to these errors should be reflected in vv_p.c.
 */
#define	VVE_NOERROR	0		/* indicates no error;must be 0 */
#define	VVE_NOMEM	1		/* couldn't allocate memory	*/
#define	VVE_SYS		2		/* system error (check errno)	*/
#define	VVE_DOWN	3		/* RP not processing requests	*/
#define	VVE_INTERNAL	4		/* internal error		*/
#define	VVE_BADPACKET	5		/* packet check failed		*/
#define	VVE_IO		6		/* I/O error			*/
#define VVE_USER	7		/* user gave bad parameter	*/
#define VVE_DBASE	8		/* dbase error/inconsistency	*/
#define VVE_ADMIN	9		/* data base inconsistency	*/
#define VVE_PERM	10		/* permission denied		*/
#define	VVE_NOTFOUND	11		/* volume can't be located	*/
#define	VVE_UNAVAIL	12		/* resource unavailable/in use	*/
#define VVE_OPS		13		/* ops problem - not logged in	*/
#define VVE_CANCELED	14		/* request was canceled		*/
#define VVE_COMM	15		/* communications problem 	*/
#define VVE_HARDWARE	16		/* problem in the real world	*/
#define VVE_TAPE	17		/* unexpected contents of tape	*/
#define VVE_FILE	18		/* problem with vv file		*/
#define VVE_NOSPC	19		/* can't write any more - full	*/
