/*
 * Terminology:
 *	a "header" is a vvpHdr_t
 *	a "message" is an associated data structure
 *	a "packet" is a contiguous header and (optional) message
 *
 *	VV_MSGPTR() returns a pointer to the message of a packet given
 *		a header pointer and the message struct type
 *	VV_PKTSIZ() returns the size of the packet given the message
 *		struct type, including some extra bytes in case it's
 *		needed for alignment
 */

#define VVNOSEQ			((vvSeq_t)-1)

#define	emsgcpy(dst,src) if (src)					\
			strncpy((dst),(src),LINELEN),dst[LINELEN-1] = '\0'; \
			else dst[0] = '\0'

#define VV_MSGPTR(hdrptr, struct)  ((struct *)((char *)(hdrptr) + \
					PadSize(sizeof(vvpHdr_t))))

#ifndef MAX
#define MAX(a,b)		((a) > (b) ? (a) : (b))
#endif
#define	VV_PKTSIZ(struct)	(sizeof(vvpHdr_t) + 16 + sizeof (struct))

