/*
 *  vv_sock.h:
 */

#define VV_SOCKTIMEOUT	5

#include <stdio.h>
#include <string.h>
#include <sys/socket.h>
#include <netdb.h>
#include <netinet/in.h>


/*
 *  Sock_t: for managing sockets
 */
typedef struct Sock {
	int		sock_flags;		/* socket flags		    */
	int		sock_fd;		/* socket fd                */
	int		sock_id;		/* socket id (pid) 	    */
	vvId_t		sock_sndkey;
	vvId_t		sock_rcvkey;
	XDR		*sock_xdrp;
	/* 'process' info used by servers: */
	int		sock_ptype;		/* type of process	    */
	int		sock_q;			/* next client waiting on req*/
	void		*sock_proc;		/* process info		    */
	void		*sock_host;		/* host info		    */
	struct in_addr	sock_addr;		/* host addr		    */
} Sock_t;

/* for sock_ptype  */
#define S_NOSOCK	0
#define S_CONNECTED	1
#define S_TIMER		2
#define S_MOVER		3
#define S_CLIENT	4

