/*
 *  vvdebug - NAStore Virtual Volume Manager console cmd
 *
 *	Bill Ross, NASA Ames, November 1997
 */

#include "vv_space.h"

char	*arg0 = NULL;


  static void
usage()
{
	(void)fprintf(stderr, "usage: %s [012] [loglevel]\n", arg0);
}

bomb()
{
	(void)fprintf(stderr, "exiting\n");
	exit(1);
	return(0);  /* for compiler warnings */
}

main(int argc, char *argv[])
{
	char		buf[VV_PKTSIZ(vvpDebug_t)];
	vvpHdr_t	*hp, *rhp;
	vvpDebug_t	*dp;
	vvpError_t	*ep;
	int		cc;

	arg0 = argv[0];

	if (getuid() != 0) {
		(void)fprintf(stderr, "%s: must be root\n", arg0);
		exit(1);
	}

	if (argc < 2  ||  argc > 3)
		usage();

	nLogInit(arg0, bomb);
	nLogInitStderr(EL_ERROR1|EL_STATUS1);
	VVCLInit(NULL, VVM_CLIENT, RETRY_FATAL);

	hp = vvBuildHdr(VVM_DEBUG, VVNOSEQ, (vvpHdr_t *)buf);
	dp = VV_MSGPTR(hp, vvpDebug_t);
        dp->vd_cmd = atoi(argv[1]);
	if (dp->vd_cmd == 0)
        	dp->vd_level = atoi(argv[2]); 

	/*
	 *  msg is built - send it
	 */
	(void)VVCLSend(hp, 1);		/* dies if problem */
	VVCLGoodbye(0);
}
