/*
 *  Virtual Volume Manager
 *
 *  vv_req.h: per-volume-request data structure
 *
 */

/*
 *  Req_t: one of these exists for each volume request received by the vvmd
 *
 */
typedef struct	Req {
	QLink_t		vr_vrq;		/* ReqQ item			*/
	QLink_t		vr_cvrq;	/* client ReqQ item		*/
	vv_t		vr_vol;
	int		vr_slot;	/* Client index in sock array	*/
	Host_t		*vr_hostp;	/* host that req came from	*/
	int		vr_clhost;	/* host index /requestor client	*/
	int		vr_cmd;		/* request type from vv_pkt.h	*/
	Seq_t		vr_clseq;	/* msg seq no of client req	*/
	Seq_t		vr_vvseq;	/* msg seq no of vvmd req	*/
	Seq_t		vr_rpord;	/* order of req in vvmd		*/
	int		vr_state;	/* request state VS_		*/
	VVInfo_t	vr_info;	/* dbase info on volume		*/
	int	 	vr_retrycnt;	/* retry count			*/
	time_t		vr_time;	/* timeouts			*/
} Req_t;


