
/*
 *  Virtual Volume Manager
 *
 *  vvtimer.c: Virtual Volume Manager support process - started by vvmd
 *
 */

#include <stdio.h>
#include <signal.h>
#include <time.h>

#include "vv_space.h"

char	*arg0 = NULL;

done()
{
	exit(1);
	return(1);	/* for compiler warnings */
}

/*
 *  Timer():
 */
void
Timer(secs)
{
	char		buf[VV_PKTSIZ(vvpTimer_t)];
	vvpHdr_t	*hp;
	vvpTimer_t	*tp;
	int		err;

	hp = vvBuildHdr(VVM_TIMER, VVNOSEQ, (vvpHdr_t *)buf);
	tp = VV_MSGPTR(hp, vvpTimer_t);

	for (;;) {
		sleep(secs);
		(void)time((time_t *)&tp->vt_time);
		VVCLSend(hp, 1);
	}
}
main(int argc, char *argv[])
{
	int	err, flag, interval = 0;
	char	buf[100];

	arg0 = argv[0];

	/*
	**	get out of the way in case core is dumped
	*/
	if (chdir("/tmp") == -1) {
		perror("chdir(/tmp)");
		exit(7);
	}
	if (argc != 2) {
		(void)fprintf(stderr, "usage: %s SECONDS\n", argv[0]);
		exit(7);
	}
	interval = atoi(argv[1]);
	if (interval <= 0) {
		(void)fprintf(stderr, "usage: %s SECONDS\n", argv[0]);
		exit(7);
	}

	(void)sprintf(buf, "%s_%d", argv[0], getpid());
	nLogInit(buf, done);
	nLogInitFile(vvLogFile(), EL_LEVEL, 0, NULL);
	nLogInitConsole(vv_syslog, EL_CONSOLE0, EL_LEVEL);
	flag = 0;
	VVCLInit(NULL, VVM_TIMERD, RETRY_FATAL);
	if (SIGNAL(SIGINT, done))
		nLogMsg(EL_FATAL|EL_SYS, 0, "signal SIGINT");
	err = Timer(interval);	/* returns when a write to the RP fails */
	return (err);
}


