/*      $NetBSD: menutree.h,v 1.3 2005/01/11 23:11:05 peter Exp $       */

/*
 * Copyright (c) 2000 The NetBSD Foundation, Inc.
 * All rights reserved.
 *  
 * Copyright (c) 2000 Tim Rightnour <garbled@NetBSD.org>  
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
 * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef _MENUTREE_H_
#define _MENUTREE_H_

CIRCLEQ_HEAD(cqMenu, menuentry);

typedef struct menuentry {
	struct cqMenu cqSubMenuHead;	/* CIRCLEQ_HEAD */
	CIRCLEQ_ENTRY(menuentry) cqMenuEntries;

	char	*path;
	char	*filename;
	char	*itemname;
	char	*quickname;
} MTREE_ENTRY;

extern struct cqMenu *cqMenuHeadp;

#define TREE_ISEMPTY(cqm)	(CIRCLEQ_FIRST(cqm) == (void *)cqm)

void tree_init(void);
void tree_appenditem(struct cqMenu *, char *, char *, char *, char *);
int tree_entries(struct cqMenu *);
MTREE_ENTRY *tree_getentry(struct cqMenu *, int);
MTREE_ENTRY *tree_gettreebyname(struct cqMenu *, char *);
void tree_printtree(struct cqMenu *);

#endif	/* _MENUTREE_H_ */
